********************************************************************************************************************;
**** Data Requested: HCV/HIV Clearance Casecade
**** Requestor: Yale
********************************************************************************************************************;

options ls=110 ps=32767 formdlim='#' sastrace=',,,sa' sastraceloc=saslog nostsuffix 
      FORMCHAR="|----|+|---+=|-/\<>*" mprint mlogic workterm;

libname cc 'C:\Users\harta6\OneDrive - State of Michigan DTMB\Desktop\Yale_Update\Aug 2022';

/*Importing raw data set from MDSS*/
proc import out = cc.hcv19_20
	datafile = "C:\Users\harta6\OneDrive - State of Michigan DTMB\Desktop\Yale_Update\Aug 2022\coinfect labs.csv"
	dbms = csv replace;
	guessingrows=max;
run;

/*Formatting bracketed test name, result, date identifiers so they are able to be delimited and transposed uniformly*/
data labs1;
	set cc.hcv19_20;
	
collection_date=tranwrd(collection_date, "[1]", "|001]");
collection_date=tranwrd(collection_date, "[2]", "|002]");
collection_date=tranwrd(collection_date, "[3]", "|003]");
collection_date=tranwrd(collection_date, "[4]", "|004]");
collection_date=tranwrd(collection_date, "[5]", "|005]");
collection_date=tranwrd(collection_date, "[6]", "|006]");
collection_date=tranwrd(collection_date, "[7]", "|007]");
collection_date=tranwrd(collection_date, "[8]", "|008]");
collection_date=tranwrd(collection_date, "[9]", "|009]");
collection_date=tranwrd(collection_date, "[10]", "|010]");
collection_date=tranwrd(collection_date, "[11]", "|011]");
collection_date=tranwrd(collection_date, "[12]", "|012]");
collection_date=tranwrd(collection_date, "[13]", "|013]");
collection_date=tranwrd(collection_date, "[14]", "|014]");
collection_date=tranwrd(collection_date, "[15]", "|015]");
collection_date=tranwrd(collection_date, "[16]", "|016]");
collection_date=tranwrd(collection_date, "[17]", "|017]");
collection_date=tranwrd(collection_date, "[18]", "|018]");
collection_date=tranwrd(collection_date, "[19]", "|019]");
collection_date=tranwrd(collection_date, "[20]", "|020]");
collection_date=tranwrd(collection_date, "[21]", "|021]");
collection_date=tranwrd(collection_date, "[22]", "|022]");
collection_date=tranwrd(collection_date, "[23]", "|023]");
collection_date=tranwrd(collection_date, "[24]", "|024]");
collection_date=tranwrd(collection_date, "[25]", "|025]");
collection_date=tranwrd(collection_date, "[26]", "|026]");
collection_date=tranwrd(collection_date, "[27]", "|027]");
collection_date=tranwrd(collection_date, "[28]", "|028]");
collection_date=tranwrd(collection_date, "[29]", "|029]");
collection_date=tranwrd(collection_date, "[30]", "|030]");
collection_date=tranwrd(collection_date, "[31]", "|031]");
collection_date=tranwrd(collection_date, "[32]", "|032]");
collection_date=tranwrd(collection_date, "[33]", "|033]");
collection_date=tranwrd(collection_date, "[34]", "|034]");
collection_date=tranwrd(collection_date, "[35]", "|035]");
collection_date=tranwrd(collection_date, "[36]", "|036]");
collection_date=tranwrd(collection_date, "[37]", "|037]");
collection_date=tranwrd(collection_date, "[38]", "|038]");
collection_date=tranwrd(collection_date, "[39]", "|039]");
collection_date=tranwrd(collection_date, "[40]", "|040]");
collection_date=tranwrd(collection_date, "[41]", "|041]");
collection_date=tranwrd(collection_date, "[42]", "|042]");
collection_date=tranwrd(collection_date, "[43]", "|043]");
collection_date=tranwrd(collection_date, "[44]", "|044]");
collection_date=tranwrd(collection_date, "[45]", "|045]");
collection_date=tranwrd(collection_date, "[46]", "|046]");
collection_date=tranwrd(collection_date, "[47]", "|047]");
collection_date=tranwrd(collection_date, "[48]", "|048]");
collection_date=tranwrd(collection_date, "[49]", "|049]");
collection_date=tranwrd(collection_date, "[50]", "|050]");
collection_date=tranwrd(collection_date, "[51]", "|051]");
collection_date=tranwrd(collection_date, "[52]", "|052]");
collection_date=tranwrd(collection_date, "[53]", "|053]");
collection_date=tranwrd(collection_date, "[54]", "|054]");
collection_date=tranwrd(collection_date, "[55]", "|055]");
collection_date=tranwrd(collection_date, "[56]", "|056]");
collection_date=tranwrd(collection_date, "[57]", "|057]");
collection_date=tranwrd(collection_date, "[58]", "|058]");
collection_date=tranwrd(collection_date, "[59]", "|059]");
collection_date=tranwrd(collection_date, "[60]", "|060]");
collection_date=tranwrd(collection_date, "[61]", "|061]");
collection_date=tranwrd(collection_date, "[62]", "|062]");
collection_date=tranwrd(collection_date, "[63]", "|063]");
collection_date=tranwrd(collection_date, "[64]", "|064]");
collection_date=tranwrd(collection_date, "[65]", "|065]");
collection_date=tranwrd(collection_date, "[66]", "|066]");
collection_date=tranwrd(collection_date, "[67]", "|067]");
collection_date=tranwrd(collection_date, "[68]", "|068]");
collection_date=tranwrd(collection_date, "[69]", "|069]");
collection_date=tranwrd(collection_date, "[70]", "|070]");
collection_date=tranwrd(collection_date, "[71]", "|071]");
collection_date=tranwrd(collection_date, "[72]", "|072]");
collection_date=tranwrd(collection_date, "[73]", "|073]");
collection_date=tranwrd(collection_date, "[74]", "|074]");
collection_date=tranwrd(collection_date, "[75]", "|075]");
collection_date=tranwrd(collection_date, "[76]", "|076]");
collection_date=tranwrd(collection_date, "[77]", "|077]");
collection_date=tranwrd(collection_date, "[78]", "|078]");
collection_date=tranwrd(collection_date, "[79]", "|079]");
collection_date=tranwrd(collection_date, "[80]", "|080]");
collection_date=tranwrd(collection_date, "[81]", "|081]");
collection_date=tranwrd(collection_date, "[82]", "|082]");
collection_date=tranwrd(collection_date, "[83]", "|083]");
collection_date=tranwrd(collection_date, "[84]", "|084]");
collection_date=tranwrd(collection_date, "[85]", "|085]");
collection_date=tranwrd(collection_date, "[86]", "|086]");
collection_date=tranwrd(collection_date, "[87]", "|087]");
collection_date=tranwrd(collection_date, "[88]", "|088]");
collection_date=tranwrd(collection_date, "[89]", "|089]");
collection_date=tranwrd(collection_date, "[90]", "|090]");
collection_date=tranwrd(collection_date, "[91]", "|091]");
collection_date=tranwrd(collection_date, "[92]", "|092]");
collection_date=tranwrd(collection_date, "[93]", "|093]");
collection_date=tranwrd(collection_date, "[94]", "|094]");
collection_date=tranwrd(collection_date, "[95]", "|095]");
collection_date=tranwrd(collection_date, "[96]", "|096]");
collection_date=tranwrd(collection_date, "[97]", "|097]");
collection_date=tranwrd(collection_date, "[98]", "|098]");
collection_date=tranwrd(collection_date, "[99]", "|099]");
collection_date=tranwrd(collection_date, "[100]", "|100]");
collection_date=tranwrd(collection_date, "[101]", "|101]");
collection_date=tranwrd(collection_date, "[102]", "|102]");
collection_date=tranwrd(collection_date, "[103]", "|103]");
collection_date=tranwrd(collection_date, "[104]", "|104]");
collection_date=tranwrd(collection_date, "[105]", "|105]");
collection_date=tranwrd(collection_date, "[106]", "|106]");
collection_date=tranwrd(collection_date, "[107]", "|107]");
collection_date=tranwrd(collection_date, "[108]", "|108]");
collection_date=tranwrd(collection_date, "[109]", "|109]");
collection_date=tranwrd(collection_date, "[110]", "|110]");
collection_date=tranwrd(collection_date, "[111]", "|111]");
collection_date=tranwrd(collection_date, "[112]", "|112]");
collection_date=tranwrd(collection_date, "[113]", "|113]");
collection_date=tranwrd(collection_date, "[114]", "|114]");
collection_date=tranwrd(collection_date, "[115]", "|115]");
collection_date=tranwrd(collection_date, "[116]", "|116]");
collection_date=tranwrd(collection_date, "[117]", "|117]");
collection_date=tranwrd(collection_date, "[118]", "|118]");
collection_date=tranwrd(collection_date, "[119]", "|119]");
collection_date=tranwrd(collection_date, "[120]", "|120]");
collection_date=tranwrd(collection_date, "[121]", "|121]");
collection_date=tranwrd(collection_date, "[122]", "|122]");
collection_date=tranwrd(collection_date, "[123]", "|123]");
collection_date=tranwrd(collection_date, "[124]", "|124]");
collection_date=tranwrd(collection_date, "[125]", "|125]");
collection_date=tranwrd(collection_date, "[126]", "|126]");
collection_date=tranwrd(collection_date, "[127]", "|127]");
collection_date=tranwrd(collection_date, "[128]", "|128]");
collection_date=tranwrd(collection_date, "[129]", "|129]");
collection_date=tranwrd(collection_date, "[130]", "|130]");
collection_date=tranwrd(collection_date, "[131]", "|131]");
collection_date=tranwrd(collection_date, "[132]", "|132]");
collection_date=tranwrd(collection_date, "[133]", "|133]");
collection_date=tranwrd(collection_date, "[134]", "|134]");
collection_date=tranwrd(collection_date, "[135]", "|135]");
collection_date=tranwrd(collection_date, "[136]", "|136]");
collection_date=tranwrd(collection_date, "[137]", "|137]");
collection_date=tranwrd(collection_date, "[138]", "|138]");
collection_date=tranwrd(collection_date, "[139]", "|139]");
collection_date=tranwrd(collection_date, "[140]", "|140]");
collection_date=tranwrd(collection_date, "[141]", "|141]");
collection_date=tranwrd(collection_date, "[142]", "|142]");
collection_date=tranwrd(collection_date, "[143]", "|143]");
collection_date=tranwrd(collection_date, "[144]", "|144]");
collection_date=tranwrd(collection_date, "[145]", "|145]");
collection_date=tranwrd(collection_date, "[146]", "|146]");
collection_date=tranwrd(collection_date, "[147]", "|147]");
collection_date=tranwrd(collection_date, "[148]", "|148]");
collection_date=tranwrd(collection_date, "[149]", "|149]");
collection_date=tranwrd(collection_date, "[150]", "|150]");
collection_date=tranwrd(collection_date, "[151]", "|151]");
collection_date=tranwrd(collection_date, "[152]", "|152]");
collection_date=tranwrd(collection_date, "[153]", "|153]");
collection_date=tranwrd(collection_date, "[154]", "|154]");
collection_date=tranwrd(collection_date, "[155]", "|155]");
collection_date=tranwrd(collection_date, "[156]", "|156]");
collection_date=tranwrd(collection_date, "[157]", "|157]");
collection_date=tranwrd(collection_date, "[158]", "|158]");
collection_date=tranwrd(collection_date, "[159]", "|159]");
collection_date=tranwrd(collection_date, "[160]", "|160]");
collection_date=tranwrd(collection_date, "[161]", "|161]");
collection_date=tranwrd(collection_date, "[162]", "|162]");
collection_date=tranwrd(collection_date, "[163]", "|163]");
collection_date=tranwrd(collection_date, "[164]", "|164]");
collection_date=tranwrd(collection_date, "[165]", "|165]");
collection_date=tranwrd(collection_date, "[166]", "|166]");
collection_date=tranwrd(collection_date, "[167]", "|167]");
collection_date=tranwrd(collection_date, "[168]", "|168]");
collection_date=tranwrd(collection_date, "[169]", "|169]");
collection_date=tranwrd(collection_date, "[170]", "|170]");
collection_date=tranwrd(collection_date, "[171]", "|171]");
collection_date=tranwrd(collection_date, "[172]", "|172]");
collection_date=tranwrd(collection_date, "[173]", "|173]");
collection_date=tranwrd(collection_date, "[174]", "|174]");
collection_date=tranwrd(collection_date, "[175]", "|175]");
collection_date=tranwrd(collection_date, "[176]", "|176]");
collection_date=tranwrd(collection_date, "[177]", "|177]");
collection_date=tranwrd(collection_date, "[178]", "|178]");
collection_date=tranwrd(collection_date, "[179]", "|179]");
collection_date=tranwrd(collection_date, "[180]", "|180]");
collection_date=tranwrd(collection_date, "[181]", "|181]");
collection_date=tranwrd(collection_date, "[182]", "|182]");
collection_date=tranwrd(collection_date, "[183]", "|183]");
collection_date=tranwrd(collection_date, "[184]", "|184]");
collection_date=tranwrd(collection_date, "[185]", "|185]");
collection_date=tranwrd(collection_date, "[186]", "|186]");
collection_date=tranwrd(collection_date, "[187]", "|187]");
collection_date=tranwrd(collection_date, "[188]", "|188]");
collection_date=tranwrd(collection_date, "[189]", "|189]");
collection_date=tranwrd(collection_date, "[190]", "|190]");
collection_date=tranwrd(collection_date, "[191]", "|191]");
collection_date=tranwrd(collection_date, "[192]", "|192]");
collection_date=tranwrd(collection_date, "[193]", "|193]");
collection_date=tranwrd(collection_date, "[194]", "|194]");
collection_date=tranwrd(collection_date, "[195]", "|195]");
collection_date=tranwrd(collection_date, "[196]", "|196]");
collection_date=tranwrd(collection_date, "[197]", "|197]");
collection_date=tranwrd(collection_date, "[198]", "|198]");
collection_date=tranwrd(collection_date, "[199]", "|199]");
collection_date=tranwrd(collection_date, "[200]", "|200]");

if collection_date = ' ' then collection_date = '|001]01/01/1900';
if collection_date = '|001]' then collection_date = '|001]01/01/1900';
run;



data labs2;
	set labs1;

reported_test_name=tranwrd(reported_test_name, "[1]", "|001]");
reported_test_name=tranwrd(reported_test_name, "[2]", "|002]");
reported_test_name=tranwrd(reported_test_name, "[3]", "|003]");
reported_test_name=tranwrd(reported_test_name, "[4]", "|004]");
reported_test_name=tranwrd(reported_test_name, "[5]", "|005]");
reported_test_name=tranwrd(reported_test_name, "[6]", "|006]");
reported_test_name=tranwrd(reported_test_name, "[7]", "|007]");
reported_test_name=tranwrd(reported_test_name, "[8]", "|008]");
reported_test_name=tranwrd(reported_test_name, "[9]", "|009]");
reported_test_name=tranwrd(reported_test_name, "[10]", "|010]");
reported_test_name=tranwrd(reported_test_name, "[11]", "|011]");
reported_test_name=tranwrd(reported_test_name, "[12]", "|012]");
reported_test_name=tranwrd(reported_test_name, "[13]", "|013]");
reported_test_name=tranwrd(reported_test_name, "[14]", "|014]");
reported_test_name=tranwrd(reported_test_name, "[15]", "|015]");
reported_test_name=tranwrd(reported_test_name, "[16]", "|016]");
reported_test_name=tranwrd(reported_test_name, "[17]", "|017]");
reported_test_name=tranwrd(reported_test_name, "[18]", "|018]");
reported_test_name=tranwrd(reported_test_name, "[19]", "|019]");
reported_test_name=tranwrd(reported_test_name, "[20]", "|020]");
reported_test_name=tranwrd(reported_test_name, "[21]", "|021]");
reported_test_name=tranwrd(reported_test_name, "[22]", "|022]");
reported_test_name=tranwrd(reported_test_name, "[23]", "|023]");
reported_test_name=tranwrd(reported_test_name, "[24]", "|024]");
reported_test_name=tranwrd(reported_test_name, "[25]", "|025]");
reported_test_name=tranwrd(reported_test_name, "[26]", "|026]");
reported_test_name=tranwrd(reported_test_name, "[27]", "|027]");
reported_test_name=tranwrd(reported_test_name, "[28]", "|028]");
reported_test_name=tranwrd(reported_test_name, "[29]", "|029]");
reported_test_name=tranwrd(reported_test_name, "[30]", "|030]");
reported_test_name=tranwrd(reported_test_name, "[31]", "|031]");
reported_test_name=tranwrd(reported_test_name, "[32]", "|032]");
reported_test_name=tranwrd(reported_test_name, "[33]", "|033]");
reported_test_name=tranwrd(reported_test_name, "[34]", "|034]");
reported_test_name=tranwrd(reported_test_name, "[35]", "|035]");
reported_test_name=tranwrd(reported_test_name, "[36]", "|036]");
reported_test_name=tranwrd(reported_test_name, "[37]", "|037]");
reported_test_name=tranwrd(reported_test_name, "[38]", "|038]");
reported_test_name=tranwrd(reported_test_name, "[39]", "|039]");
reported_test_name=tranwrd(reported_test_name, "[40]", "|040]");
reported_test_name=tranwrd(reported_test_name, "[41]", "|041]");
reported_test_name=tranwrd(reported_test_name, "[42]", "|042]");
reported_test_name=tranwrd(reported_test_name, "[43]", "|043]");
reported_test_name=tranwrd(reported_test_name, "[44]", "|044]");
reported_test_name=tranwrd(reported_test_name, "[45]", "|045]");
reported_test_name=tranwrd(reported_test_name, "[46]", "|046]");
reported_test_name=tranwrd(reported_test_name, "[47]", "|047]");
reported_test_name=tranwrd(reported_test_name, "[48]", "|048]");
reported_test_name=tranwrd(reported_test_name, "[49]", "|049]");
reported_test_name=tranwrd(reported_test_name, "[50]", "|050]");
reported_test_name=tranwrd(reported_test_name, "[51]", "|051]");
reported_test_name=tranwrd(reported_test_name, "[52]", "|052]");
reported_test_name=tranwrd(reported_test_name, "[53]", "|053]");
reported_test_name=tranwrd(reported_test_name, "[54]", "|054]");
reported_test_name=tranwrd(reported_test_name, "[55]", "|055]");
reported_test_name=tranwrd(reported_test_name, "[56]", "|056]");
reported_test_name=tranwrd(reported_test_name, "[57]", "|057]");
reported_test_name=tranwrd(reported_test_name, "[58]", "|058]");
reported_test_name=tranwrd(reported_test_name, "[59]", "|059]");
reported_test_name=tranwrd(reported_test_name, "[60]", "|060]");
reported_test_name=tranwrd(reported_test_name, "[61]", "|061]");
reported_test_name=tranwrd(reported_test_name, "[62]", "|062]");
reported_test_name=tranwrd(reported_test_name, "[63]", "|063]");
reported_test_name=tranwrd(reported_test_name, "[64]", "|064]");
reported_test_name=tranwrd(reported_test_name, "[65]", "|065]");
reported_test_name=tranwrd(reported_test_name, "[66]", "|066]");
reported_test_name=tranwrd(reported_test_name, "[67]", "|067]");
reported_test_name=tranwrd(reported_test_name, "[68]", "|068]");
reported_test_name=tranwrd(reported_test_name, "[69]", "|069]");
reported_test_name=tranwrd(reported_test_name, "[70]", "|070]");
reported_test_name=tranwrd(reported_test_name, "[71]", "|071]");
reported_test_name=tranwrd(reported_test_name, "[72]", "|072]");
reported_test_name=tranwrd(reported_test_name, "[73]", "|073]");
reported_test_name=tranwrd(reported_test_name, "[74]", "|074]");
reported_test_name=tranwrd(reported_test_name, "[75]", "|075]");
reported_test_name=tranwrd(reported_test_name, "[76]", "|076]");
reported_test_name=tranwrd(reported_test_name, "[77]", "|077]");
reported_test_name=tranwrd(reported_test_name, "[78]", "|078]");
reported_test_name=tranwrd(reported_test_name, "[79]", "|079]");
reported_test_name=tranwrd(reported_test_name, "[80]", "|080]");
reported_test_name=tranwrd(reported_test_name, "[81]", "|081]");
reported_test_name=tranwrd(reported_test_name, "[82]", "|082]");
reported_test_name=tranwrd(reported_test_name, "[83]", "|083]");
reported_test_name=tranwrd(reported_test_name, "[84]", "|084]");
reported_test_name=tranwrd(reported_test_name, "[85]", "|085]");
reported_test_name=tranwrd(reported_test_name, "[86]", "|086]");
reported_test_name=tranwrd(reported_test_name, "[87]", "|087]");
reported_test_name=tranwrd(reported_test_name, "[88]", "|088]");
reported_test_name=tranwrd(reported_test_name, "[89]", "|089]");
reported_test_name=tranwrd(reported_test_name, "[90]", "|090]");
reported_test_name=tranwrd(reported_test_name, "[91]", "|091]");
reported_test_name=tranwrd(reported_test_name, "[92]", "|092]");
reported_test_name=tranwrd(reported_test_name, "[93]", "|093]");
reported_test_name=tranwrd(reported_test_name, "[94]", "|094]");
reported_test_name=tranwrd(reported_test_name, "[95]", "|095]");
reported_test_name=tranwrd(reported_test_name, "[96]", "|096]");
reported_test_name=tranwrd(reported_test_name, "[97]", "|097]");
reported_test_name=tranwrd(reported_test_name, "[98]", "|098]");
reported_test_name=tranwrd(reported_test_name, "[99]", "|099]");
reported_test_name=tranwrd(reported_test_name, "[100]", "|100]");
reported_test_name=tranwrd(reported_test_name, "[101]", "|101]");
reported_test_name=tranwrd(reported_test_name, "[102]", "|102]");
reported_test_name=tranwrd(reported_test_name, "[103]", "|103]");
reported_test_name=tranwrd(reported_test_name, "[104]", "|104]");
reported_test_name=tranwrd(reported_test_name, "[105]", "|105]");
reported_test_name=tranwrd(reported_test_name, "[106]", "|106]");
reported_test_name=tranwrd(reported_test_name, "[107]", "|107]");
reported_test_name=tranwrd(reported_test_name, "[108]", "|108]");
reported_test_name=tranwrd(reported_test_name, "[109]", "|109]");
reported_test_name=tranwrd(reported_test_name, "[110]", "|110]");
reported_test_name=tranwrd(reported_test_name, "[111]", "|111]");
reported_test_name=tranwrd(reported_test_name, "[112]", "|112]");
reported_test_name=tranwrd(reported_test_name, "[113]", "|113]");
reported_test_name=tranwrd(reported_test_name, "[114]", "|114]");
reported_test_name=tranwrd(reported_test_name, "[115]", "|115]");
reported_test_name=tranwrd(reported_test_name, "[116]", "|116]");
reported_test_name=tranwrd(reported_test_name, "[117]", "|117]");
reported_test_name=tranwrd(reported_test_name, "[118]", "|118]");
reported_test_name=tranwrd(reported_test_name, "[119]", "|119]");
reported_test_name=tranwrd(reported_test_name, "[120]", "|120]");
reported_test_name=tranwrd(reported_test_name, "[121]", "|121]");
reported_test_name=tranwrd(reported_test_name, "[122]", "|122]");
reported_test_name=tranwrd(reported_test_name, "[123]", "|123]");
reported_test_name=tranwrd(reported_test_name, "[124]", "|124]");
reported_test_name=tranwrd(reported_test_name, "[125]", "|125]");
reported_test_name=tranwrd(reported_test_name, "[126]", "|126]");
reported_test_name=tranwrd(reported_test_name, "[127]", "|127]");
reported_test_name=tranwrd(reported_test_name, "[128]", "|128]");
reported_test_name=tranwrd(reported_test_name, "[129]", "|129]");
reported_test_name=tranwrd(reported_test_name, "[130]", "|130]");
reported_test_name=tranwrd(reported_test_name, "[131]", "|131]");
reported_test_name=tranwrd(reported_test_name, "[132]", "|132]");
reported_test_name=tranwrd(reported_test_name, "[133]", "|133]");
reported_test_name=tranwrd(reported_test_name, "[134]", "|134]");
reported_test_name=tranwrd(reported_test_name, "[135]", "|135]");
reported_test_name=tranwrd(reported_test_name, "[136]", "|136]");
reported_test_name=tranwrd(reported_test_name, "[137]", "|137]");
reported_test_name=tranwrd(reported_test_name, "[138]", "|138]");
reported_test_name=tranwrd(reported_test_name, "[139]", "|139]");
reported_test_name=tranwrd(reported_test_name, "[140]", "|140]");
reported_test_name=tranwrd(reported_test_name, "[141]", "|141]");
reported_test_name=tranwrd(reported_test_name, "[142]", "|142]");
reported_test_name=tranwrd(reported_test_name, "[143]", "|143]");
reported_test_name=tranwrd(reported_test_name, "[144]", "|144]");
reported_test_name=tranwrd(reported_test_name, "[145]", "|145]");
reported_test_name=tranwrd(reported_test_name, "[146]", "|146]");
reported_test_name=tranwrd(reported_test_name, "[147]", "|147]");
reported_test_name=tranwrd(reported_test_name, "[148]", "|148]");
reported_test_name=tranwrd(reported_test_name, "[149]", "|149]");
reported_test_name=tranwrd(reported_test_name, "[150]", "|150]");
reported_test_name=tranwrd(reported_test_name, "[151]", "|151]");
reported_test_name=tranwrd(reported_test_name, "[152]", "|152]");
reported_test_name=tranwrd(reported_test_name, "[153]", "|153]");
reported_test_name=tranwrd(reported_test_name, "[154]", "|154]");
reported_test_name=tranwrd(reported_test_name, "[155]", "|155]");
reported_test_name=tranwrd(reported_test_name, "[156]", "|156]");
reported_test_name=tranwrd(reported_test_name, "[157]", "|157]");
reported_test_name=tranwrd(reported_test_name, "[158]", "|158]");
reported_test_name=tranwrd(reported_test_name, "[159]", "|159]");
reported_test_name=tranwrd(reported_test_name, "[160]", "|160]");
reported_test_name=tranwrd(reported_test_name, "[161]", "|161]");
reported_test_name=tranwrd(reported_test_name, "[162]", "|162]");
reported_test_name=tranwrd(reported_test_name, "[163]", "|163]");
reported_test_name=tranwrd(reported_test_name, "[164]", "|164]");
reported_test_name=tranwrd(reported_test_name, "[165]", "|165]");
reported_test_name=tranwrd(reported_test_name, "[166]", "|166]");
reported_test_name=tranwrd(reported_test_name, "[167]", "|167]");
reported_test_name=tranwrd(reported_test_name, "[168]", "|168]");
reported_test_name=tranwrd(reported_test_name, "[169]", "|169]");
reported_test_name=tranwrd(reported_test_name, "[170]", "|170]");
reported_test_name=tranwrd(reported_test_name, "[171]", "|171]");
reported_test_name=tranwrd(reported_test_name, "[172]", "|172]");
reported_test_name=tranwrd(reported_test_name, "[173]", "|173]");
reported_test_name=tranwrd(reported_test_name, "[174]", "|174]");
reported_test_name=tranwrd(reported_test_name, "[175]", "|175]");
reported_test_name=tranwrd(reported_test_name, "[176]", "|176]");
reported_test_name=tranwrd(reported_test_name, "[177]", "|177]");
reported_test_name=tranwrd(reported_test_name, "[178]", "|178]");
reported_test_name=tranwrd(reported_test_name, "[179]", "|179]");
reported_test_name=tranwrd(reported_test_name, "[180]", "|180]");
reported_test_name=tranwrd(reported_test_name, "[181]", "|181]");
reported_test_name=tranwrd(reported_test_name, "[182]", "|182]");
reported_test_name=tranwrd(reported_test_name, "[183]", "|183]");
reported_test_name=tranwrd(reported_test_name, "[184]", "|184]");
reported_test_name=tranwrd(reported_test_name, "[185]", "|185]");
reported_test_name=tranwrd(reported_test_name, "[186]", "|186]");
reported_test_name=tranwrd(reported_test_name, "[187]", "|187]");
reported_test_name=tranwrd(reported_test_name, "[188]", "|188]");
reported_test_name=tranwrd(reported_test_name, "[189]", "|189]");
reported_test_name=tranwrd(reported_test_name, "[190]", "|190]");
reported_test_name=tranwrd(reported_test_name, "[191]", "|191]");
reported_test_name=tranwrd(reported_test_name, "[192]", "|192]");
reported_test_name=tranwrd(reported_test_name, "[193]", "|193]");
reported_test_name=tranwrd(reported_test_name, "[194]", "|194]");
reported_test_name=tranwrd(reported_test_name, "[195]", "|195]");
reported_test_name=tranwrd(reported_test_name, "[196]", "|196]");
reported_test_name=tranwrd(reported_test_name, "[197]", "|197]");
reported_test_name=tranwrd(reported_test_name, "[198]", "|198]");
reported_test_name=tranwrd(reported_test_name, "[199]", "|199]");
reported_test_name=tranwrd(reported_test_name, "[200]", "|200]");

if reported_test_name = ' ' then reported_test_name = '|001]UNK';
if reported_test_name = '|001]' then reported_test_name = '|001]UNK';

run;

data labs3;
	set labs2;


test_result=tranwrd(test_result, "[1]", "|001]");
test_result=tranwrd(test_result, "[2]", "|002]");
test_result=tranwrd(test_result, "[3]", "|003]");
test_result=tranwrd(test_result, "[4]", "|004]");
test_result=tranwrd(test_result, "[5]", "|005]");
test_result=tranwrd(test_result, "[6]", "|006]");
test_result=tranwrd(test_result, "[7]", "|007]");
test_result=tranwrd(test_result, "[8]", "|008]");
test_result=tranwrd(test_result, "[9]", "|009]");
test_result=tranwrd(test_result, "[10]", "|010]");
test_result=tranwrd(test_result, "[11]", "|011]");
test_result=tranwrd(test_result, "[12]", "|012]");
test_result=tranwrd(test_result, "[13]", "|013]");
test_result=tranwrd(test_result, "[14]", "|014]");
test_result=tranwrd(test_result, "[15]", "|015]");
test_result=tranwrd(test_result, "[16]", "|016]");
test_result=tranwrd(test_result, "[17]", "|017]");
test_result=tranwrd(test_result, "[18]", "|018]");
test_result=tranwrd(test_result, "[19]", "|019]");
test_result=tranwrd(test_result, "[20]", "|020]");
test_result=tranwrd(test_result, "[21]", "|021]");
test_result=tranwrd(test_result, "[22]", "|022]");
test_result=tranwrd(test_result, "[23]", "|023]");
test_result=tranwrd(test_result, "[24]", "|024]");
test_result=tranwrd(test_result, "[25]", "|025]");
test_result=tranwrd(test_result, "[26]", "|026]");
test_result=tranwrd(test_result, "[27]", "|027]");
test_result=tranwrd(test_result, "[28]", "|028]");
test_result=tranwrd(test_result, "[29]", "|029]");
test_result=tranwrd(test_result, "[30]", "|030]");
test_result=tranwrd(test_result, "[31]", "|031]");
test_result=tranwrd(test_result, "[32]", "|032]");
test_result=tranwrd(test_result, "[33]", "|033]");
test_result=tranwrd(test_result, "[34]", "|034]");
test_result=tranwrd(test_result, "[35]", "|035]");
test_result=tranwrd(test_result, "[36]", "|036]");
test_result=tranwrd(test_result, "[37]", "|037]");
test_result=tranwrd(test_result, "[38]", "|038]");
test_result=tranwrd(test_result, "[39]", "|039]");
test_result=tranwrd(test_result, "[40]", "|040]");
test_result=tranwrd(test_result, "[41]", "|041]");
test_result=tranwrd(test_result, "[42]", "|042]");
test_result=tranwrd(test_result, "[43]", "|043]");
test_result=tranwrd(test_result, "[44]", "|044]");
test_result=tranwrd(test_result, "[45]", "|045]");
test_result=tranwrd(test_result, "[46]", "|046]");
test_result=tranwrd(test_result, "[47]", "|047]");
test_result=tranwrd(test_result, "[48]", "|048]");
test_result=tranwrd(test_result, "[49]", "|049]");
test_result=tranwrd(test_result, "[50]", "|050]");
test_result=tranwrd(test_result, "[51]", "|051]");
test_result=tranwrd(test_result, "[52]", "|052]");
test_result=tranwrd(test_result, "[53]", "|053]");
test_result=tranwrd(test_result, "[54]", "|054]");
test_result=tranwrd(test_result, "[55]", "|055]");
test_result=tranwrd(test_result, "[56]", "|056]");
test_result=tranwrd(test_result, "[57]", "|057]");
test_result=tranwrd(test_result, "[58]", "|058]");
test_result=tranwrd(test_result, "[59]", "|059]");
test_result=tranwrd(test_result, "[60]", "|060]");
test_result=tranwrd(test_result, "[61]", "|061]");
test_result=tranwrd(test_result, "[62]", "|062]");
test_result=tranwrd(test_result, "[63]", "|063]");
test_result=tranwrd(test_result, "[64]", "|064]");
test_result=tranwrd(test_result, "[65]", "|065]");
test_result=tranwrd(test_result, "[66]", "|066]");
test_result=tranwrd(test_result, "[67]", "|067]");
test_result=tranwrd(test_result, "[68]", "|068]");
test_result=tranwrd(test_result, "[69]", "|069]");
test_result=tranwrd(test_result, "[70]", "|070]");
test_result=tranwrd(test_result, "[71]", "|071]");
test_result=tranwrd(test_result, "[72]", "|072]");
test_result=tranwrd(test_result, "[73]", "|073]");
test_result=tranwrd(test_result, "[74]", "|074]");
test_result=tranwrd(test_result, "[75]", "|075]");
test_result=tranwrd(test_result, "[76]", "|076]");
test_result=tranwrd(test_result, "[77]", "|077]");
test_result=tranwrd(test_result, "[78]", "|078]");
test_result=tranwrd(test_result, "[79]", "|079]");
test_result=tranwrd(test_result, "[80]", "|080]");
test_result=tranwrd(test_result, "[81]", "|081]");
test_result=tranwrd(test_result, "[82]", "|082]");
test_result=tranwrd(test_result, "[83]", "|083]");
test_result=tranwrd(test_result, "[84]", "|084]");
test_result=tranwrd(test_result, "[85]", "|085]");
test_result=tranwrd(test_result, "[86]", "|086]");
test_result=tranwrd(test_result, "[87]", "|087]");
test_result=tranwrd(test_result, "[88]", "|088]");
test_result=tranwrd(test_result, "[89]", "|089]");
test_result=tranwrd(test_result, "[90]", "|090]");
test_result=tranwrd(test_result, "[91]", "|091]");
test_result=tranwrd(test_result, "[92]", "|092]");
test_result=tranwrd(test_result, "[93]", "|093]");
test_result=tranwrd(test_result, "[94]", "|094]");
test_result=tranwrd(test_result, "[95]", "|095]");
test_result=tranwrd(test_result, "[96]", "|096]");
test_result=tranwrd(test_result, "[97]", "|097]");
test_result=tranwrd(test_result, "[98]", "|098]");
test_result=tranwrd(test_result, "[99]", "|099]");
test_result=tranwrd(test_result, "[100]", "|100]");
test_result=tranwrd(test_result, "[101]", "|101]");
test_result=tranwrd(test_result, "[102]", "|102]");
test_result=tranwrd(test_result, "[103]", "|103]");
test_result=tranwrd(test_result, "[104]", "|104]");
test_result=tranwrd(test_result, "[105]", "|105]");
test_result=tranwrd(test_result, "[106]", "|106]");
test_result=tranwrd(test_result, "[107]", "|107]");
test_result=tranwrd(test_result, "[108]", "|108]");
test_result=tranwrd(test_result, "[109]", "|109]");
test_result=tranwrd(test_result, "[110]", "|110]");
test_result=tranwrd(test_result, "[111]", "|111]");
test_result=tranwrd(test_result, "[112]", "|112]");
test_result=tranwrd(test_result, "[113]", "|113]");
test_result=tranwrd(test_result, "[114]", "|114]");
test_result=tranwrd(test_result, "[115]", "|115]");
test_result=tranwrd(test_result, "[116]", "|116]");
test_result=tranwrd(test_result, "[117]", "|117]");
test_result=tranwrd(test_result, "[118]", "|118]");
test_result=tranwrd(test_result, "[119]", "|119]");
test_result=tranwrd(test_result, "[120]", "|120]");
test_result=tranwrd(test_result, "[121]", "|121]");
test_result=tranwrd(test_result, "[122]", "|122]");
test_result=tranwrd(test_result, "[123]", "|123]");
test_result=tranwrd(test_result, "[124]", "|124]");
test_result=tranwrd(test_result, "[125]", "|125]");
test_result=tranwrd(test_result, "[126]", "|126]");
test_result=tranwrd(test_result, "[127]", "|127]");
test_result=tranwrd(test_result, "[128]", "|128]");
test_result=tranwrd(test_result, "[129]", "|129]");
test_result=tranwrd(test_result, "[130]", "|130]");
test_result=tranwrd(test_result, "[131]", "|131]");
test_result=tranwrd(test_result, "[132]", "|132]");
test_result=tranwrd(test_result, "[133]", "|133]");
test_result=tranwrd(test_result, "[134]", "|134]");
test_result=tranwrd(test_result, "[135]", "|135]");
test_result=tranwrd(test_result, "[136]", "|136]");
test_result=tranwrd(test_result, "[137]", "|137]");
test_result=tranwrd(test_result, "[138]", "|138]");
test_result=tranwrd(test_result, "[139]", "|139]");
test_result=tranwrd(test_result, "[140]", "|140]");
test_result=tranwrd(test_result, "[141]", "|141]");
test_result=tranwrd(test_result, "[142]", "|142]");
test_result=tranwrd(test_result, "[143]", "|143]");
test_result=tranwrd(test_result, "[144]", "|144]");
test_result=tranwrd(test_result, "[145]", "|145]");
test_result=tranwrd(test_result, "[146]", "|146]");
test_result=tranwrd(test_result, "[147]", "|147]");
test_result=tranwrd(test_result, "[148]", "|148]");
test_result=tranwrd(test_result, "[149]", "|149]");
test_result=tranwrd(test_result, "[150]", "|150]");
test_result=tranwrd(test_result, "[151]", "|151]");
test_result=tranwrd(test_result, "[152]", "|152]");
test_result=tranwrd(test_result, "[153]", "|153]");
test_result=tranwrd(test_result, "[154]", "|154]");
test_result=tranwrd(test_result, "[155]", "|155]");
test_result=tranwrd(test_result, "[156]", "|156]");
test_result=tranwrd(test_result, "[157]", "|157]");
test_result=tranwrd(test_result, "[158]", "|158]");
test_result=tranwrd(test_result, "[159]", "|159]");
test_result=tranwrd(test_result, "[160]", "|160]");
test_result=tranwrd(test_result, "[161]", "|161]");
test_result=tranwrd(test_result, "[162]", "|162]");
test_result=tranwrd(test_result, "[163]", "|163]");
test_result=tranwrd(test_result, "[164]", "|164]");
test_result=tranwrd(test_result, "[165]", "|165]");
test_result=tranwrd(test_result, "[166]", "|166]");
test_result=tranwrd(test_result, "[167]", "|167]");
test_result=tranwrd(test_result, "[168]", "|168]");
test_result=tranwrd(test_result, "[169]", "|169]");
test_result=tranwrd(test_result, "[170]", "|170]");
test_result=tranwrd(test_result, "[171]", "|171]");
test_result=tranwrd(test_result, "[172]", "|172]");
test_result=tranwrd(test_result, "[173]", "|173]");
test_result=tranwrd(test_result, "[174]", "|174]");
test_result=tranwrd(test_result, "[175]", "|175]");
test_result=tranwrd(test_result, "[176]", "|176]");
test_result=tranwrd(test_result, "[177]", "|177]");
test_result=tranwrd(test_result, "[178]", "|178]");
test_result=tranwrd(test_result, "[179]", "|179]");
test_result=tranwrd(test_result, "[180]", "|180]");
test_result=tranwrd(test_result, "[181]", "|181]");
test_result=tranwrd(test_result, "[182]", "|182]");
test_result=tranwrd(test_result, "[183]", "|183]");
test_result=tranwrd(test_result, "[184]", "|184]");
test_result=tranwrd(test_result, "[185]", "|185]");
test_result=tranwrd(test_result, "[186]", "|186]");
test_result=tranwrd(test_result, "[187]", "|187]");
test_result=tranwrd(test_result, "[188]", "|188]");
test_result=tranwrd(test_result, "[189]", "|189]");
test_result=tranwrd(test_result, "[190]", "|190]");
test_result=tranwrd(test_result, "[191]", "|191]");
test_result=tranwrd(test_result, "[192]", "|192]");
test_result=tranwrd(test_result, "[193]", "|193]");
test_result=tranwrd(test_result, "[194]", "|194]");
test_result=tranwrd(test_result, "[195]", "|195]");
test_result=tranwrd(test_result, "[196]", "|196]");
test_result=tranwrd(test_result, "[197]", "|197]");
test_result=tranwrd(test_result, "[198]", "|198]");
test_result=tranwrd(test_result, "[199]", "|199]");
test_result=tranwrd(test_result, "[200]", "|200]");

if test_result = ' ' then test_result = '|001]UNK';
if test_result = '|001]' then test_result = '|001]UNK';

run;

data labs4;
	set labs3;
report_date=tranwrd(report_date, "[1]", "|001]");
report_date=tranwrd(report_date, "[2]", "|002]");
report_date=tranwrd(report_date, "[3]", "|003]");
report_date=tranwrd(report_date, "[4]", "|004]");
report_date=tranwrd(report_date, "[5]", "|005]");
report_date=tranwrd(report_date, "[6]", "|006]");
report_date=tranwrd(report_date, "[7]", "|007]");
report_date=tranwrd(report_date, "[8]", "|008]");
report_date=tranwrd(report_date, "[9]", "|009]");
report_date=tranwrd(report_date, "[10]", "|010]");
report_date=tranwrd(report_date, "[11]", "|011]");
report_date=tranwrd(report_date, "[12]", "|012]");
report_date=tranwrd(report_date, "[13]", "|013]");
report_date=tranwrd(report_date, "[14]", "|014]");
report_date=tranwrd(report_date, "[15]", "|015]");
report_date=tranwrd(report_date, "[16]", "|016]");
report_date=tranwrd(report_date, "[17]", "|017]");
report_date=tranwrd(report_date, "[18]", "|018]");
report_date=tranwrd(report_date, "[19]", "|019]");
report_date=tranwrd(report_date, "[20]", "|020]");
report_date=tranwrd(report_date, "[21]", "|021]");
report_date=tranwrd(report_date, "[22]", "|022]");
report_date=tranwrd(report_date, "[23]", "|023]");
report_date=tranwrd(report_date, "[24]", "|024]");
report_date=tranwrd(report_date, "[25]", "|025]");
report_date=tranwrd(report_date, "[26]", "|026]");
report_date=tranwrd(report_date, "[27]", "|027]");
report_date=tranwrd(report_date, "[28]", "|028]");
report_date=tranwrd(report_date, "[29]", "|029]");
report_date=tranwrd(report_date, "[30]", "|030]");
report_date=tranwrd(report_date, "[31]", "|031]");
report_date=tranwrd(report_date, "[32]", "|032]");
report_date=tranwrd(report_date, "[33]", "|033]");
report_date=tranwrd(report_date, "[34]", "|034]");
report_date=tranwrd(report_date, "[35]", "|035]");
report_date=tranwrd(report_date, "[36]", "|036]");
report_date=tranwrd(report_date, "[37]", "|037]");
report_date=tranwrd(report_date, "[38]", "|038]");
report_date=tranwrd(report_date, "[39]", "|039]");
report_date=tranwrd(report_date, "[40]", "|040]");
report_date=tranwrd(report_date, "[41]", "|041]");
report_date=tranwrd(report_date, "[42]", "|042]");
report_date=tranwrd(report_date, "[43]", "|043]");
report_date=tranwrd(report_date, "[44]", "|044]");
report_date=tranwrd(report_date, "[45]", "|045]");
report_date=tranwrd(report_date, "[46]", "|046]");
report_date=tranwrd(report_date, "[47]", "|047]");
report_date=tranwrd(report_date, "[48]", "|048]");
report_date=tranwrd(report_date, "[49]", "|049]");
report_date=tranwrd(report_date, "[50]", "|050]");
report_date=tranwrd(report_date, "[51]", "|051]");
report_date=tranwrd(report_date, "[52]", "|052]");
report_date=tranwrd(report_date, "[53]", "|053]");
report_date=tranwrd(report_date, "[54]", "|054]");
report_date=tranwrd(report_date, "[55]", "|055]");
report_date=tranwrd(report_date, "[56]", "|056]");
report_date=tranwrd(report_date, "[57]", "|057]");
report_date=tranwrd(report_date, "[58]", "|058]");
report_date=tranwrd(report_date, "[59]", "|059]");
report_date=tranwrd(report_date, "[60]", "|060]");
report_date=tranwrd(report_date, "[61]", "|061]");
report_date=tranwrd(report_date, "[62]", "|062]");
report_date=tranwrd(report_date, "[63]", "|063]");
report_date=tranwrd(report_date, "[64]", "|064]");
report_date=tranwrd(report_date, "[65]", "|065]");
report_date=tranwrd(report_date, "[66]", "|066]");
report_date=tranwrd(report_date, "[67]", "|067]");
report_date=tranwrd(report_date, "[68]", "|068]");
report_date=tranwrd(report_date, "[69]", "|069]");
report_date=tranwrd(report_date, "[70]", "|070]");
report_date=tranwrd(report_date, "[71]", "|071]");
report_date=tranwrd(report_date, "[72]", "|072]");
report_date=tranwrd(report_date, "[73]", "|073]");
report_date=tranwrd(report_date, "[74]", "|074]");
report_date=tranwrd(report_date, "[75]", "|075]");
report_date=tranwrd(report_date, "[76]", "|076]");
report_date=tranwrd(report_date, "[77]", "|077]");
report_date=tranwrd(report_date, "[78]", "|078]");
report_date=tranwrd(report_date, "[79]", "|079]");
report_date=tranwrd(report_date, "[80]", "|080]");
report_date=tranwrd(report_date, "[81]", "|081]");
report_date=tranwrd(report_date, "[82]", "|082]");
report_date=tranwrd(report_date, "[83]", "|083]");
report_date=tranwrd(report_date, "[84]", "|084]");
report_date=tranwrd(report_date, "[85]", "|085]");
report_date=tranwrd(report_date, "[86]", "|086]");
report_date=tranwrd(report_date, "[87]", "|087]");
report_date=tranwrd(report_date, "[88]", "|088]");
report_date=tranwrd(report_date, "[89]", "|089]");
report_date=tranwrd(report_date, "[90]", "|090]");
report_date=tranwrd(report_date, "[91]", "|091]");
report_date=tranwrd(report_date, "[92]", "|092]");
report_date=tranwrd(report_date, "[93]", "|093]");
report_date=tranwrd(report_date, "[94]", "|094]");
report_date=tranwrd(report_date, "[95]", "|095]");
report_date=tranwrd(report_date, "[96]", "|096]");
report_date=tranwrd(report_date, "[97]", "|097]");
report_date=tranwrd(report_date, "[98]", "|098]");
report_date=tranwrd(report_date, "[99]", "|099]");
report_date=tranwrd(report_date, "[100]", "|100]");
report_date=tranwrd(report_date, "[101]", "|101]");
report_date=tranwrd(report_date, "[102]", "|102]");
report_date=tranwrd(report_date, "[103]", "|103]");
report_date=tranwrd(report_date, "[104]", "|104]");
report_date=tranwrd(report_date, "[105]", "|105]");
report_date=tranwrd(report_date, "[106]", "|106]");
report_date=tranwrd(report_date, "[107]", "|107]");
report_date=tranwrd(report_date, "[108]", "|108]");
report_date=tranwrd(report_date, "[109]", "|109]");
report_date=tranwrd(report_date, "[110]", "|110]");
report_date=tranwrd(report_date, "[111]", "|111]");
report_date=tranwrd(report_date, "[112]", "|112]");
report_date=tranwrd(report_date, "[113]", "|113]");
report_date=tranwrd(report_date, "[114]", "|114]");
report_date=tranwrd(report_date, "[115]", "|115]");
report_date=tranwrd(report_date, "[116]", "|116]");
report_date=tranwrd(report_date, "[117]", "|117]");
report_date=tranwrd(report_date, "[118]", "|118]");
report_date=tranwrd(report_date, "[119]", "|119]");
report_date=tranwrd(report_date, "[120]", "|120]");
report_date=tranwrd(report_date, "[121]", "|121]");
report_date=tranwrd(report_date, "[122]", "|122]");
report_date=tranwrd(report_date, "[123]", "|123]");
report_date=tranwrd(report_date, "[124]", "|124]");
report_date=tranwrd(report_date, "[125]", "|125]");
report_date=tranwrd(report_date, "[126]", "|126]");
report_date=tranwrd(report_date, "[127]", "|127]");
report_date=tranwrd(report_date, "[128]", "|128]");
report_date=tranwrd(report_date, "[129]", "|129]");
report_date=tranwrd(report_date, "[130]", "|130]");
report_date=tranwrd(report_date, "[131]", "|131]");
report_date=tranwrd(report_date, "[132]", "|132]");
report_date=tranwrd(report_date, "[133]", "|133]");
report_date=tranwrd(report_date, "[134]", "|134]");
report_date=tranwrd(report_date, "[135]", "|135]");
report_date=tranwrd(report_date, "[136]", "|136]");
report_date=tranwrd(report_date, "[137]", "|137]");
report_date=tranwrd(report_date, "[138]", "|138]");
report_date=tranwrd(report_date, "[139]", "|139]");
report_date=tranwrd(report_date, "[140]", "|140]");
report_date=tranwrd(report_date, "[141]", "|141]");
report_date=tranwrd(report_date, "[142]", "|142]");
report_date=tranwrd(report_date, "[143]", "|143]");
report_date=tranwrd(report_date, "[144]", "|144]");
report_date=tranwrd(report_date, "[145]", "|145]");
report_date=tranwrd(report_date, "[146]", "|146]");
report_date=tranwrd(report_date, "[147]", "|147]");
report_date=tranwrd(report_date, "[148]", "|148]");
report_date=tranwrd(report_date, "[149]", "|149]");
report_date=tranwrd(report_date, "[150]", "|150]");
report_date=tranwrd(report_date, "[151]", "|151]");
report_date=tranwrd(report_date, "[152]", "|152]");
report_date=tranwrd(report_date, "[153]", "|153]");
report_date=tranwrd(report_date, "[154]", "|154]");
report_date=tranwrd(report_date, "[155]", "|155]");
report_date=tranwrd(report_date, "[156]", "|156]");
report_date=tranwrd(report_date, "[157]", "|157]");
report_date=tranwrd(report_date, "[158]", "|158]");
report_date=tranwrd(report_date, "[159]", "|159]");
report_date=tranwrd(report_date, "[160]", "|160]");
report_date=tranwrd(report_date, "[161]", "|161]");
report_date=tranwrd(report_date, "[162]", "|162]");
report_date=tranwrd(report_date, "[163]", "|163]");
report_date=tranwrd(report_date, "[164]", "|164]");
report_date=tranwrd(report_date, "[165]", "|165]");
report_date=tranwrd(report_date, "[166]", "|166]");
report_date=tranwrd(report_date, "[167]", "|167]");
report_date=tranwrd(report_date, "[168]", "|168]");
report_date=tranwrd(report_date, "[169]", "|169]");
report_date=tranwrd(report_date, "[170]", "|170]");
report_date=tranwrd(report_date, "[171]", "|171]");
report_date=tranwrd(report_date, "[172]", "|172]");
report_date=tranwrd(report_date, "[173]", "|173]");
report_date=tranwrd(report_date, "[174]", "|174]");
report_date=tranwrd(report_date, "[175]", "|175]");
report_date=tranwrd(report_date, "[176]", "|176]");
report_date=tranwrd(report_date, "[177]", "|177]");
report_date=tranwrd(report_date, "[178]", "|178]");
report_date=tranwrd(report_date, "[179]", "|179]");
report_date=tranwrd(report_date, "[180]", "|180]");
report_date=tranwrd(report_date, "[181]", "|181]");
report_date=tranwrd(report_date, "[182]", "|182]");
report_date=tranwrd(report_date, "[183]", "|183]");
report_date=tranwrd(report_date, "[184]", "|184]");
report_date=tranwrd(report_date, "[185]", "|185]");
report_date=tranwrd(report_date, "[186]", "|186]");
report_date=tranwrd(report_date, "[187]", "|187]");
report_date=tranwrd(report_date, "[188]", "|188]");
report_date=tranwrd(report_date, "[189]", "|189]");
report_date=tranwrd(report_date, "[190]", "|190]");
report_date=tranwrd(report_date, "[191]", "|191]");
report_date=tranwrd(report_date, "[192]", "|192]");
report_date=tranwrd(report_date, "[193]", "|193]");
report_date=tranwrd(report_date, "[194]", "|194]");
report_date=tranwrd(report_date, "[195]", "|195]");
report_date=tranwrd(report_date, "[196]", "|196]");
report_date=tranwrd(report_date, "[197]", "|197]");
report_date=tranwrd(report_date, "[198]", "|198]");
report_date=tranwrd(report_date, "[199]", "|199]");
report_date=tranwrd(report_date, "[200]", "|200]");

if report_date = ' ' then report_date = '|001]01/01/1900';
if report_date = '|001]' then report_date = '|001]01/01/1900';

run;

/*Delimiting test name, result, date so each cell contains a singular data point rather than a string of multiple tests*/
data test_name (keep = investigationid reported_test_name test_name1-test_name200);
	set labs4;
	format test_name1-test_name200 $1000.;

test_name1=substr(scan(reported_test_name,1,"|"),5);
test_name2=substr(scan(reported_test_name,2,"|"),5);
test_name3=substr(scan(reported_test_name,3,"|"),5);
test_name4=substr(scan(reported_test_name,4,"|"),5);
test_name5=substr(scan(reported_test_name,5,"|"),5);
test_name6=substr(scan(reported_test_name,6,"|"),5);
test_name7=substr(scan(reported_test_name,7,"|"),5);
test_name8=substr(scan(reported_test_name,8,"|"),5);
test_name9=substr(scan(reported_test_name,9,"|"),5);
test_name10=substr(scan(reported_test_name,10,"|"),5);
test_name11=substr(scan(reported_test_name,11,"|"),5);
test_name12=substr(scan(reported_test_name,12,"|"),5);
test_name13=substr(scan(reported_test_name,13,"|"),5);
test_name14=substr(scan(reported_test_name,14,"|"),5);
test_name15=substr(scan(reported_test_name,15,"|"),5);
test_name16=substr(scan(reported_test_name,16,"|"),5);
test_name17=substr(scan(reported_test_name,17,"|"),5);
test_name18=substr(scan(reported_test_name,18,"|"),5);
test_name19=substr(scan(reported_test_name,19,"|"),5);
test_name20=substr(scan(reported_test_name,20,"|"),5);
test_name21=substr(scan(reported_test_name,21,"|"),5);
test_name22=substr(scan(reported_test_name,22,"|"),5);
test_name23=substr(scan(reported_test_name,23,"|"),5);
test_name24=substr(scan(reported_test_name,24,"|"),5);
test_name25=substr(scan(reported_test_name,25,"|"),5);
test_name26=substr(scan(reported_test_name,26,"|"),5);
test_name27=substr(scan(reported_test_name,27,"|"),5);
test_name28=substr(scan(reported_test_name,28,"|"),5);
test_name29=substr(scan(reported_test_name,29,"|"),5);
test_name30=substr(scan(reported_test_name,30,"|"),5);
test_name31=substr(scan(reported_test_name,31,"|"),5);
test_name32=substr(scan(reported_test_name,32,"|"),5);
test_name33=substr(scan(reported_test_name,33,"|"),5);
test_name34=substr(scan(reported_test_name,34,"|"),5);
test_name35=substr(scan(reported_test_name,35,"|"),5);
test_name36=substr(scan(reported_test_name,36,"|"),5);
test_name37=substr(scan(reported_test_name,37,"|"),5);
test_name38=substr(scan(reported_test_name,38,"|"),5);
test_name39=substr(scan(reported_test_name,39,"|"),5);
test_name40=substr(scan(reported_test_name,40,"|"),5);
test_name41=substr(scan(reported_test_name,41,"|"),5);
test_name42=substr(scan(reported_test_name,42,"|"),5);
test_name43=substr(scan(reported_test_name,43,"|"),5);
test_name44=substr(scan(reported_test_name,44,"|"),5);
test_name45=substr(scan(reported_test_name,45,"|"),5);
test_name46=substr(scan(reported_test_name,46,"|"),5);
test_name47=substr(scan(reported_test_name,47,"|"),5);
test_name48=substr(scan(reported_test_name,48,"|"),5);
test_name49=substr(scan(reported_test_name,49,"|"),5);
test_name50=substr(scan(reported_test_name,50,"|"),5);
test_name51=substr(scan(reported_test_name,51,"|"),5);
test_name52=substr(scan(reported_test_name,52,"|"),5);
test_name53=substr(scan(reported_test_name,53,"|"),5);
test_name54=substr(scan(reported_test_name,54,"|"),5);
test_name55=substr(scan(reported_test_name,55,"|"),5);
test_name56=substr(scan(reported_test_name,56,"|"),5);
test_name57=substr(scan(reported_test_name,57,"|"),5);
test_name58=substr(scan(reported_test_name,58,"|"),5);
test_name59=substr(scan(reported_test_name,59,"|"),5);
test_name60=substr(scan(reported_test_name,60,"|"),5);
test_name61=substr(scan(reported_test_name,61,"|"),5);
test_name62=substr(scan(reported_test_name,62,"|"),5);
test_name63=substr(scan(reported_test_name,63,"|"),5);
test_name64=substr(scan(reported_test_name,64,"|"),5);
test_name65=substr(scan(reported_test_name,65,"|"),5);
test_name66=substr(scan(reported_test_name,66,"|"),5);
test_name67=substr(scan(reported_test_name,67,"|"),5);
test_name68=substr(scan(reported_test_name,68,"|"),5);
test_name69=substr(scan(reported_test_name,69,"|"),5);
test_name70=substr(scan(reported_test_name,70,"|"),5);
test_name71=substr(scan(reported_test_name,71,"|"),5);
test_name72=substr(scan(reported_test_name,72,"|"),5);
test_name73=substr(scan(reported_test_name,73,"|"),5);
test_name74=substr(scan(reported_test_name,74,"|"),5);
test_name75=substr(scan(reported_test_name,75,"|"),5);
test_name76=substr(scan(reported_test_name,76,"|"),5);
test_name77=substr(scan(reported_test_name,77,"|"),5);
test_name78=substr(scan(reported_test_name,78,"|"),5);
test_name79=substr(scan(reported_test_name,79,"|"),5);
test_name80=substr(scan(reported_test_name,80,"|"),5);
test_name81=substr(scan(reported_test_name,81,"|"),5);
test_name82=substr(scan(reported_test_name,82,"|"),5);
test_name83=substr(scan(reported_test_name,83,"|"),5);
test_name84=substr(scan(reported_test_name,84,"|"),5);
test_name85=substr(scan(reported_test_name,85,"|"),5);
test_name86=substr(scan(reported_test_name,86,"|"),5);
test_name87=substr(scan(reported_test_name,87,"|"),5);
test_name88=substr(scan(reported_test_name,88,"|"),5);
test_name89=substr(scan(reported_test_name,89,"|"),5);
test_name90=substr(scan(reported_test_name,90,"|"),5);
test_name91=substr(scan(reported_test_name,91,"|"),5);
test_name92=substr(scan(reported_test_name,92,"|"),5);
test_name93=substr(scan(reported_test_name,93,"|"),5);
test_name94=substr(scan(reported_test_name,94,"|"),5);
test_name95=substr(scan(reported_test_name,95,"|"),5);
test_name96=substr(scan(reported_test_name,96,"|"),5);
test_name97=substr(scan(reported_test_name,97,"|"),5);
test_name98=substr(scan(reported_test_name,98,"|"),5);
test_name99=substr(scan(reported_test_name,99,"|"),5);
test_name100=substr(scan(reported_test_name,100,"|"),5);
test_name101=substr(scan(reported_test_name,101,"|"),5);
test_name102=substr(scan(reported_test_name,102,"|"),5);
test_name103=substr(scan(reported_test_name,103,"|"),5);
test_name104=substr(scan(reported_test_name,104,"|"),5);
test_name105=substr(scan(reported_test_name,105,"|"),5);
test_name106=substr(scan(reported_test_name,106,"|"),5);
test_name107=substr(scan(reported_test_name,107,"|"),5);
test_name108=substr(scan(reported_test_name,108,"|"),5);
test_name109=substr(scan(reported_test_name,109,"|"),5);
test_name110=substr(scan(reported_test_name,110,"|"),5);
test_name111=substr(scan(reported_test_name,111,"|"),5);
test_name112=substr(scan(reported_test_name,112,"|"),5);
test_name113=substr(scan(reported_test_name,113,"|"),5);
test_name114=substr(scan(reported_test_name,114,"|"),5);
test_name115=substr(scan(reported_test_name,115,"|"),5);
test_name116=substr(scan(reported_test_name,116,"|"),5);
test_name117=substr(scan(reported_test_name,117,"|"),5);
test_name118=substr(scan(reported_test_name,118,"|"),5);
test_name119=substr(scan(reported_test_name,119,"|"),5);
test_name120=substr(scan(reported_test_name,120,"|"),5);
test_name121=substr(scan(reported_test_name,121,"|"),5);
test_name122=substr(scan(reported_test_name,122,"|"),5);
test_name123=substr(scan(reported_test_name,123,"|"),5);
test_name124=substr(scan(reported_test_name,124,"|"),5);
test_name125=substr(scan(reported_test_name,125,"|"),5);
test_name126=substr(scan(reported_test_name,126,"|"),5);
test_name127=substr(scan(reported_test_name,127,"|"),5);
test_name128=substr(scan(reported_test_name,128,"|"),5);
test_name129=substr(scan(reported_test_name,129,"|"),5);
test_name130=substr(scan(reported_test_name,130,"|"),5);
test_name131=substr(scan(reported_test_name,131,"|"),5);
test_name132=substr(scan(reported_test_name,132,"|"),5);
test_name133=substr(scan(reported_test_name,133,"|"),5);
test_name134=substr(scan(reported_test_name,134,"|"),5);
test_name135=substr(scan(reported_test_name,135,"|"),5);
test_name136=substr(scan(reported_test_name,136,"|"),5);
test_name137=substr(scan(reported_test_name,137,"|"),5);
test_name138=substr(scan(reported_test_name,138,"|"),5);
test_name139=substr(scan(reported_test_name,139,"|"),5);
test_name140=substr(scan(reported_test_name,140,"|"),5);
test_name141=substr(scan(reported_test_name,141,"|"),5);
test_name142=substr(scan(reported_test_name,142,"|"),5);
test_name143=substr(scan(reported_test_name,143,"|"),5);
test_name144=substr(scan(reported_test_name,144,"|"),5);
test_name145=substr(scan(reported_test_name,145,"|"),5);
test_name146=substr(scan(reported_test_name,146,"|"),5);
test_name147=substr(scan(reported_test_name,147,"|"),5);
test_name148=substr(scan(reported_test_name,148,"|"),5);
test_name149=substr(scan(reported_test_name,149,"|"),5);
test_name150=substr(scan(reported_test_name,150,"|"),5);
test_name151=substr(scan(reported_test_name,151,"|"),5);
test_name152=substr(scan(reported_test_name,152,"|"),5);
test_name153=substr(scan(reported_test_name,153,"|"),5);
test_name154=substr(scan(reported_test_name,154,"|"),5);
test_name155=substr(scan(reported_test_name,155,"|"),5);
test_name156=substr(scan(reported_test_name,156,"|"),5);
test_name157=substr(scan(reported_test_name,157,"|"),5);
test_name158=substr(scan(reported_test_name,158,"|"),5);
test_name159=substr(scan(reported_test_name,159,"|"),5);
test_name160=substr(scan(reported_test_name,160,"|"),5);
test_name161=substr(scan(reported_test_name,161,"|"),5);
test_name162=substr(scan(reported_test_name,162,"|"),5);
test_name163=substr(scan(reported_test_name,163,"|"),5);
test_name164=substr(scan(reported_test_name,164,"|"),5);
test_name165=substr(scan(reported_test_name,165,"|"),5);
test_name166=substr(scan(reported_test_name,166,"|"),5);
test_name167=substr(scan(reported_test_name,167,"|"),5);
test_name168=substr(scan(reported_test_name,168,"|"),5);
test_name169=substr(scan(reported_test_name,169,"|"),5);
test_name170=substr(scan(reported_test_name,170,"|"),5);
test_name171=substr(scan(reported_test_name,171,"|"),5);
test_name172=substr(scan(reported_test_name,172,"|"),5);
test_name173=substr(scan(reported_test_name,173,"|"),5);
test_name174=substr(scan(reported_test_name,174,"|"),5);
test_name175=substr(scan(reported_test_name,175,"|"),5);
test_name176=substr(scan(reported_test_name,176,"|"),5);
test_name177=substr(scan(reported_test_name,177,"|"),5);
test_name178=substr(scan(reported_test_name,178,"|"),5);
test_name179=substr(scan(reported_test_name,179,"|"),5);
test_name180=substr(scan(reported_test_name,180,"|"),5);
test_name181=substr(scan(reported_test_name,181,"|"),5);
test_name182=substr(scan(reported_test_name,182,"|"),5);
test_name183=substr(scan(reported_test_name,183,"|"),5);
test_name184=substr(scan(reported_test_name,184,"|"),5);
test_name185=substr(scan(reported_test_name,185,"|"),5);
test_name186=substr(scan(reported_test_name,186,"|"),5);
test_name187=substr(scan(reported_test_name,187,"|"),5);
test_name188=substr(scan(reported_test_name,188,"|"),5);
test_name189=substr(scan(reported_test_name,189,"|"),5);
test_name190=substr(scan(reported_test_name,190,"|"),5);
test_name191=substr(scan(reported_test_name,191,"|"),5);
test_name192=substr(scan(reported_test_name,192,"|"),5);
test_name193=substr(scan(reported_test_name,193,"|"),5);
test_name194=substr(scan(reported_test_name,194,"|"),5);
test_name195=substr(scan(reported_test_name,195,"|"),5);
test_name196=substr(scan(reported_test_name,196,"|"),5);
test_name197=substr(scan(reported_test_name,197,"|"),5);
test_name198=substr(scan(reported_test_name,198,"|"),5);
test_name199=substr(scan(reported_test_name,199,"|"),5);
test_name200=substr(scan(reported_test_name,200,"|"),5);

run;


data result (keep = investigationid test_result result1-result200);
	set labs4;
	format result1-result200 $1000.;

result1=substr(scan(test_result,1,"|"),5);
result2=substr(scan(test_result,2,"|"),5);
result3=substr(scan(test_result,3,"|"),5);
result4=substr(scan(test_result,4,"|"),5);
result5=substr(scan(test_result,5,"|"),5);
result6=substr(scan(test_result,6,"|"),5);
result7=substr(scan(test_result,7,"|"),5);
result8=substr(scan(test_result,8,"|"),5);
result9=substr(scan(test_result,9,"|"),5);
result10=substr(scan(test_result,10,"|"),5);
result11=substr(scan(test_result,11,"|"),5);
result12=substr(scan(test_result,12,"|"),5);
result13=substr(scan(test_result,13,"|"),5);
result14=substr(scan(test_result,14,"|"),5);
result15=substr(scan(test_result,15,"|"),5);
result16=substr(scan(test_result,16,"|"),5);
result17=substr(scan(test_result,17,"|"),5);
result18=substr(scan(test_result,18,"|"),5);
result19=substr(scan(test_result,19,"|"),5);
result20=substr(scan(test_result,20,"|"),5);
result21=substr(scan(test_result,21,"|"),5);
result22=substr(scan(test_result,22,"|"),5);
result23=substr(scan(test_result,23,"|"),5);
result24=substr(scan(test_result,24,"|"),5);
result25=substr(scan(test_result,25,"|"),5);
result26=substr(scan(test_result,26,"|"),5);
result27=substr(scan(test_result,27,"|"),5);
result28=substr(scan(test_result,28,"|"),5);
result29=substr(scan(test_result,29,"|"),5);
result30=substr(scan(test_result,30,"|"),5);
result31=substr(scan(test_result,31,"|"),5);
result32=substr(scan(test_result,32,"|"),5);
result33=substr(scan(test_result,33,"|"),5);
result34=substr(scan(test_result,34,"|"),5);
result35=substr(scan(test_result,35,"|"),5);
result36=substr(scan(test_result,36,"|"),5);
result37=substr(scan(test_result,37,"|"),5);
result38=substr(scan(test_result,38,"|"),5);
result39=substr(scan(test_result,39,"|"),5);
result40=substr(scan(test_result,40,"|"),5);
result41=substr(scan(test_result,41,"|"),5);
result42=substr(scan(test_result,42,"|"),5);
result43=substr(scan(test_result,43,"|"),5);
result44=substr(scan(test_result,44,"|"),5);
result45=substr(scan(test_result,45,"|"),5);
result46=substr(scan(test_result,46,"|"),5);
result47=substr(scan(test_result,47,"|"),5);
result48=substr(scan(test_result,48,"|"),5);
result49=substr(scan(test_result,49,"|"),5);
result50=substr(scan(test_result,50,"|"),5);
result51=substr(scan(test_result,51,"|"),5);
result52=substr(scan(test_result,52,"|"),5);
result53=substr(scan(test_result,53,"|"),5);
result54=substr(scan(test_result,54,"|"),5);
result55=substr(scan(test_result,55,"|"),5);
result56=substr(scan(test_result,56,"|"),5);
result57=substr(scan(test_result,57,"|"),5);
result58=substr(scan(test_result,58,"|"),5);
result59=substr(scan(test_result,59,"|"),5);
result60=substr(scan(test_result,60,"|"),5);
result61=substr(scan(test_result,61,"|"),5);
result62=substr(scan(test_result,62,"|"),5);
result63=substr(scan(test_result,63,"|"),5);
result64=substr(scan(test_result,64,"|"),5);
result65=substr(scan(test_result,65,"|"),5);
result66=substr(scan(test_result,66,"|"),5);
result67=substr(scan(test_result,67,"|"),5);
result68=substr(scan(test_result,68,"|"),5);
result69=substr(scan(test_result,69,"|"),5);
result70=substr(scan(test_result,70,"|"),5);
result71=substr(scan(test_result,71,"|"),5);
result72=substr(scan(test_result,72,"|"),5);
result73=substr(scan(test_result,73,"|"),5);
result74=substr(scan(test_result,74,"|"),5);
result75=substr(scan(test_result,75,"|"),5);
result76=substr(scan(test_result,76,"|"),5);
result77=substr(scan(test_result,77,"|"),5);
result78=substr(scan(test_result,78,"|"),5);
result79=substr(scan(test_result,79,"|"),5);
result80=substr(scan(test_result,80,"|"),5);
result81=substr(scan(test_result,81,"|"),5);
result82=substr(scan(test_result,82,"|"),5);
result83=substr(scan(test_result,83,"|"),5);
result84=substr(scan(test_result,84,"|"),5);
result85=substr(scan(test_result,85,"|"),5);
result86=substr(scan(test_result,86,"|"),5);
result87=substr(scan(test_result,87,"|"),5);
result88=substr(scan(test_result,88,"|"),5);
result89=substr(scan(test_result,89,"|"),5);
result90=substr(scan(test_result,90,"|"),5);
result91=substr(scan(test_result,91,"|"),5);
result92=substr(scan(test_result,92,"|"),5);
result93=substr(scan(test_result,93,"|"),5);
result94=substr(scan(test_result,94,"|"),5);
result95=substr(scan(test_result,95,"|"),5);
result96=substr(scan(test_result,96,"|"),5);
result97=substr(scan(test_result,97,"|"),5);
result98=substr(scan(test_result,98,"|"),5);
result99=substr(scan(test_result,99,"|"),5);
result100=substr(scan(test_result,100,"|"),5);
result101=substr(scan(test_result,101,"|"),5);
result102=substr(scan(test_result,102,"|"),5);
result103=substr(scan(test_result,103,"|"),5);
result104=substr(scan(test_result,104,"|"),5);
result105=substr(scan(test_result,105,"|"),5);
result106=substr(scan(test_result,106,"|"),5);
result107=substr(scan(test_result,107,"|"),5);
result108=substr(scan(test_result,108,"|"),5);
result109=substr(scan(test_result,109,"|"),5);
result110=substr(scan(test_result,110,"|"),5);
result111=substr(scan(test_result,111,"|"),5);
result112=substr(scan(test_result,112,"|"),5);
result113=substr(scan(test_result,113,"|"),5);
result114=substr(scan(test_result,114,"|"),5);
result115=substr(scan(test_result,115,"|"),5);
result116=substr(scan(test_result,116,"|"),5);
result117=substr(scan(test_result,117,"|"),5);
result118=substr(scan(test_result,118,"|"),5);
result119=substr(scan(test_result,119,"|"),5);
result120=substr(scan(test_result,120,"|"),5);
result121=substr(scan(test_result,121,"|"),5);
result122=substr(scan(test_result,122,"|"),5);
result123=substr(scan(test_result,123,"|"),5);
result124=substr(scan(test_result,124,"|"),5);
result125=substr(scan(test_result,125,"|"),5);
result126=substr(scan(test_result,126,"|"),5);
result127=substr(scan(test_result,127,"|"),5);
result128=substr(scan(test_result,128,"|"),5);
result129=substr(scan(test_result,129,"|"),5);
result130=substr(scan(test_result,130,"|"),5);
result131=substr(scan(test_result,131,"|"),5);
result132=substr(scan(test_result,132,"|"),5);
result133=substr(scan(test_result,133,"|"),5);
result134=substr(scan(test_result,134,"|"),5);
result135=substr(scan(test_result,135,"|"),5);
result136=substr(scan(test_result,136,"|"),5);
result137=substr(scan(test_result,137,"|"),5);
result138=substr(scan(test_result,138,"|"),5);
result139=substr(scan(test_result,139,"|"),5);
result140=substr(scan(test_result,140,"|"),5);
result141=substr(scan(test_result,141,"|"),5);
result142=substr(scan(test_result,142,"|"),5);
result143=substr(scan(test_result,143,"|"),5);
result144=substr(scan(test_result,144,"|"),5);
result145=substr(scan(test_result,145,"|"),5);
result146=substr(scan(test_result,146,"|"),5);
result147=substr(scan(test_result,147,"|"),5);
result148=substr(scan(test_result,148,"|"),5);
result149=substr(scan(test_result,149,"|"),5);
result150=substr(scan(test_result,150,"|"),5);
result151=substr(scan(test_result,151,"|"),5);
result152=substr(scan(test_result,152,"|"),5);
result153=substr(scan(test_result,153,"|"),5);
result154=substr(scan(test_result,154,"|"),5);
result155=substr(scan(test_result,155,"|"),5);
result156=substr(scan(test_result,156,"|"),5);
result157=substr(scan(test_result,157,"|"),5);
result158=substr(scan(test_result,158,"|"),5);
result159=substr(scan(test_result,159,"|"),5);
result160=substr(scan(test_result,160,"|"),5);
result161=substr(scan(test_result,161,"|"),5);
result162=substr(scan(test_result,162,"|"),5);
result163=substr(scan(test_result,163,"|"),5);
result164=substr(scan(test_result,164,"|"),5);
result165=substr(scan(test_result,165,"|"),5);
result166=substr(scan(test_result,166,"|"),5);
result167=substr(scan(test_result,167,"|"),5);
result168=substr(scan(test_result,168,"|"),5);
result169=substr(scan(test_result,169,"|"),5);
result170=substr(scan(test_result,170,"|"),5);
result171=substr(scan(test_result,171,"|"),5);
result172=substr(scan(test_result,172,"|"),5);
result173=substr(scan(test_result,173,"|"),5);
result174=substr(scan(test_result,174,"|"),5);
result175=substr(scan(test_result,175,"|"),5);
result176=substr(scan(test_result,176,"|"),5);
result177=substr(scan(test_result,177,"|"),5);
result178=substr(scan(test_result,178,"|"),5);
result179=substr(scan(test_result,179,"|"),5);
result180=substr(scan(test_result,180,"|"),5);
result181=substr(scan(test_result,181,"|"),5);
result182=substr(scan(test_result,182,"|"),5);
result183=substr(scan(test_result,183,"|"),5);
result184=substr(scan(test_result,184,"|"),5);
result185=substr(scan(test_result,185,"|"),5);
result186=substr(scan(test_result,186,"|"),5);
result187=substr(scan(test_result,187,"|"),5);
result188=substr(scan(test_result,188,"|"),5);
result189=substr(scan(test_result,189,"|"),5);
result190=substr(scan(test_result,190,"|"),5);
result191=substr(scan(test_result,191,"|"),5);
result192=substr(scan(test_result,192,"|"),5);
result193=substr(scan(test_result,193,"|"),5);
result194=substr(scan(test_result,194,"|"),5);
result195=substr(scan(test_result,195,"|"),5);
result196=substr(scan(test_result,196,"|"),5);
result197=substr(scan(test_result,197,"|"),5);
result198=substr(scan(test_result,198,"|"),5);
result199=substr(scan(test_result,199,"|"),5);
result200=substr(scan(test_result,200,"|"),5);

run;



data coll_dt (keep = investigationid referral_date collection_date coll_dt1-coll_dt200);
set labs4;
coll_dt1=substr(scan(collection_date,1,"|"),5);
coll_dt2=substr(scan(collection_date,2,"|"),5);
coll_dt3=substr(scan(collection_date,3,"|"),5);
coll_dt4=substr(scan(collection_date,4,"|"),5);
coll_dt5=substr(scan(collection_date,5,"|"),5);
coll_dt6=substr(scan(collection_date,6,"|"),5);
coll_dt7=substr(scan(collection_date,7,"|"),5);
coll_dt8=substr(scan(collection_date,8,"|"),5);
coll_dt9=substr(scan(collection_date,9,"|"),5);
coll_dt10=substr(scan(collection_date,10,"|"),5);
coll_dt11=substr(scan(collection_date,11,"|"),5);
coll_dt12=substr(scan(collection_date,12,"|"),5);
coll_dt13=substr(scan(collection_date,13,"|"),5);
coll_dt14=substr(scan(collection_date,14,"|"),5);
coll_dt15=substr(scan(collection_date,15,"|"),5);
coll_dt16=substr(scan(collection_date,16,"|"),5);
coll_dt17=substr(scan(collection_date,17,"|"),5);
coll_dt18=substr(scan(collection_date,18,"|"),5);
coll_dt19=substr(scan(collection_date,19,"|"),5);
coll_dt20=substr(scan(collection_date,20,"|"),5);
coll_dt21=substr(scan(collection_date,21,"|"),5);
coll_dt22=substr(scan(collection_date,22,"|"),5);
coll_dt23=substr(scan(collection_date,23,"|"),5);
coll_dt24=substr(scan(collection_date,24,"|"),5);
coll_dt25=substr(scan(collection_date,25,"|"),5);
coll_dt26=substr(scan(collection_date,26,"|"),5);
coll_dt27=substr(scan(collection_date,27,"|"),5);
coll_dt28=substr(scan(collection_date,28,"|"),5);
coll_dt29=substr(scan(collection_date,29,"|"),5);
coll_dt30=substr(scan(collection_date,30,"|"),5);
coll_dt31=substr(scan(collection_date,31,"|"),5);
coll_dt32=substr(scan(collection_date,32,"|"),5);
coll_dt33=substr(scan(collection_date,33,"|"),5);
coll_dt34=substr(scan(collection_date,34,"|"),5);
coll_dt35=substr(scan(collection_date,35,"|"),5);
coll_dt36=substr(scan(collection_date,36,"|"),5);
coll_dt37=substr(scan(collection_date,37,"|"),5);
coll_dt38=substr(scan(collection_date,38,"|"),5);
coll_dt39=substr(scan(collection_date,39,"|"),5);
coll_dt40=substr(scan(collection_date,40,"|"),5);
coll_dt41=substr(scan(collection_date,41,"|"),5);
coll_dt42=substr(scan(collection_date,42,"|"),5);
coll_dt43=substr(scan(collection_date,43,"|"),5);
coll_dt44=substr(scan(collection_date,44,"|"),5);
coll_dt45=substr(scan(collection_date,45,"|"),5);
coll_dt46=substr(scan(collection_date,46,"|"),5);
coll_dt47=substr(scan(collection_date,47,"|"),5);
coll_dt48=substr(scan(collection_date,48,"|"),5);
coll_dt49=substr(scan(collection_date,49,"|"),5);
coll_dt50=substr(scan(collection_date,50,"|"),5);
coll_dt51=substr(scan(collection_date,51,"|"),5);
coll_dt52=substr(scan(collection_date,52,"|"),5);
coll_dt53=substr(scan(collection_date,53,"|"),5);
coll_dt54=substr(scan(collection_date,54,"|"),5);
coll_dt55=substr(scan(collection_date,55,"|"),5);
coll_dt56=substr(scan(collection_date,56,"|"),5);
coll_dt57=substr(scan(collection_date,57,"|"),5);
coll_dt58=substr(scan(collection_date,58,"|"),5);
coll_dt59=substr(scan(collection_date,59,"|"),5);
coll_dt60=substr(scan(collection_date,60,"|"),5);
coll_dt61=substr(scan(collection_date,61,"|"),5);
coll_dt62=substr(scan(collection_date,62,"|"),5);
coll_dt63=substr(scan(collection_date,63,"|"),5);
coll_dt64=substr(scan(collection_date,64,"|"),5);
coll_dt65=substr(scan(collection_date,65,"|"),5);
coll_dt66=substr(scan(collection_date,66,"|"),5);
coll_dt67=substr(scan(collection_date,67,"|"),5);
coll_dt68=substr(scan(collection_date,68,"|"),5);
coll_dt69=substr(scan(collection_date,69,"|"),5);
coll_dt70=substr(scan(collection_date,70,"|"),5);
coll_dt71=substr(scan(collection_date,71,"|"),5);
coll_dt72=substr(scan(collection_date,72,"|"),5);
coll_dt73=substr(scan(collection_date,73,"|"),5);
coll_dt74=substr(scan(collection_date,74,"|"),5);
coll_dt75=substr(scan(collection_date,75,"|"),5);
coll_dt76=substr(scan(collection_date,76,"|"),5);
coll_dt77=substr(scan(collection_date,77,"|"),5);
coll_dt78=substr(scan(collection_date,78,"|"),5);
coll_dt79=substr(scan(collection_date,79,"|"),5);
coll_dt80=substr(scan(collection_date,80,"|"),5);
coll_dt81=substr(scan(collection_date,81,"|"),5);
coll_dt82=substr(scan(collection_date,82,"|"),5);
coll_dt83=substr(scan(collection_date,83,"|"),5);
coll_dt84=substr(scan(collection_date,84,"|"),5);
coll_dt85=substr(scan(collection_date,85,"|"),5);
coll_dt86=substr(scan(collection_date,86,"|"),5);
coll_dt87=substr(scan(collection_date,87,"|"),5);
coll_dt88=substr(scan(collection_date,88,"|"),5);
coll_dt89=substr(scan(collection_date,89,"|"),5);
coll_dt90=substr(scan(collection_date,90,"|"),5);
coll_dt91=substr(scan(collection_date,91,"|"),5);
coll_dt92=substr(scan(collection_date,92,"|"),5);
coll_dt93=substr(scan(collection_date,93,"|"),5);
coll_dt94=substr(scan(collection_date,94,"|"),5);
coll_dt95=substr(scan(collection_date,95,"|"),5);
coll_dt96=substr(scan(collection_date,96,"|"),5);
coll_dt97=substr(scan(collection_date,97,"|"),5);
coll_dt98=substr(scan(collection_date,98,"|"),5);
coll_dt99=substr(scan(collection_date,99,"|"),5);
coll_dt100=substr(scan(collection_date,100,"|"),5);
coll_dt101=substr(scan(collection_date,101,"|"),5);
coll_dt102=substr(scan(collection_date,102,"|"),5);
coll_dt103=substr(scan(collection_date,103,"|"),5);
coll_dt104=substr(scan(collection_date,104,"|"),5);
coll_dt105=substr(scan(collection_date,105,"|"),5);
coll_dt106=substr(scan(collection_date,106,"|"),5);
coll_dt107=substr(scan(collection_date,107,"|"),5);
coll_dt108=substr(scan(collection_date,108,"|"),5);
coll_dt109=substr(scan(collection_date,109,"|"),5);
coll_dt110=substr(scan(collection_date,110,"|"),5);
coll_dt111=substr(scan(collection_date,111,"|"),5);
coll_dt112=substr(scan(collection_date,112,"|"),5);
coll_dt113=substr(scan(collection_date,113,"|"),5);
coll_dt114=substr(scan(collection_date,114,"|"),5);
coll_dt115=substr(scan(collection_date,115,"|"),5);
coll_dt116=substr(scan(collection_date,116,"|"),5);
coll_dt117=substr(scan(collection_date,117,"|"),5);
coll_dt118=substr(scan(collection_date,118,"|"),5);
coll_dt119=substr(scan(collection_date,119,"|"),5);
coll_dt120=substr(scan(collection_date,120,"|"),5);
coll_dt121=substr(scan(collection_date,121,"|"),5);
coll_dt122=substr(scan(collection_date,122,"|"),5);
coll_dt123=substr(scan(collection_date,123,"|"),5);
coll_dt124=substr(scan(collection_date,124,"|"),5);
coll_dt125=substr(scan(collection_date,125,"|"),5);
coll_dt126=substr(scan(collection_date,126,"|"),5);
coll_dt127=substr(scan(collection_date,127,"|"),5);
coll_dt128=substr(scan(collection_date,128,"|"),5);
coll_dt129=substr(scan(collection_date,129,"|"),5);
coll_dt130=substr(scan(collection_date,130,"|"),5);
coll_dt131=substr(scan(collection_date,131,"|"),5);
coll_dt132=substr(scan(collection_date,132,"|"),5);
coll_dt133=substr(scan(collection_date,133,"|"),5);
coll_dt134=substr(scan(collection_date,134,"|"),5);
coll_dt135=substr(scan(collection_date,135,"|"),5);
coll_dt136=substr(scan(collection_date,136,"|"),5);
coll_dt137=substr(scan(collection_date,137,"|"),5);
coll_dt138=substr(scan(collection_date,138,"|"),5);
coll_dt139=substr(scan(collection_date,139,"|"),5);
coll_dt140=substr(scan(collection_date,140,"|"),5);
coll_dt141=substr(scan(collection_date,141,"|"),5);
coll_dt142=substr(scan(collection_date,142,"|"),5);
coll_dt143=substr(scan(collection_date,143,"|"),5);
coll_dt144=substr(scan(collection_date,144,"|"),5);
coll_dt145=substr(scan(collection_date,145,"|"),5);
coll_dt146=substr(scan(collection_date,146,"|"),5);
coll_dt147=substr(scan(collection_date,147,"|"),5);
coll_dt148=substr(scan(collection_date,148,"|"),5);
coll_dt149=substr(scan(collection_date,149,"|"),5);
coll_dt150=substr(scan(collection_date,150,"|"),5);
coll_dt151=substr(scan(collection_date,151,"|"),5);
coll_dt152=substr(scan(collection_date,152,"|"),5);
coll_dt153=substr(scan(collection_date,153,"|"),5);
coll_dt154=substr(scan(collection_date,154,"|"),5);
coll_dt155=substr(scan(collection_date,155,"|"),5);
coll_dt156=substr(scan(collection_date,156,"|"),5);
coll_dt157=substr(scan(collection_date,157,"|"),5);
coll_dt158=substr(scan(collection_date,158,"|"),5);
coll_dt159=substr(scan(collection_date,159,"|"),5);
coll_dt160=substr(scan(collection_date,160,"|"),5);
coll_dt161=substr(scan(collection_date,161,"|"),5);
coll_dt162=substr(scan(collection_date,162,"|"),5);
coll_dt163=substr(scan(collection_date,163,"|"),5);
coll_dt164=substr(scan(collection_date,164,"|"),5);
coll_dt165=substr(scan(collection_date,165,"|"),5);
coll_dt166=substr(scan(collection_date,166,"|"),5);
coll_dt167=substr(scan(collection_date,167,"|"),5);
coll_dt168=substr(scan(collection_date,168,"|"),5);
coll_dt169=substr(scan(collection_date,169,"|"),5);
coll_dt170=substr(scan(collection_date,170,"|"),5);
coll_dt171=substr(scan(collection_date,171,"|"),5);
coll_dt172=substr(scan(collection_date,172,"|"),5);
coll_dt173=substr(scan(collection_date,173,"|"),5);
coll_dt174=substr(scan(collection_date,174,"|"),5);
coll_dt175=substr(scan(collection_date,175,"|"),5);
coll_dt176=substr(scan(collection_date,176,"|"),5);
coll_dt177=substr(scan(collection_date,177,"|"),5);
coll_dt178=substr(scan(collection_date,178,"|"),5);
coll_dt179=substr(scan(collection_date,179,"|"),5);
coll_dt180=substr(scan(collection_date,180,"|"),5);
coll_dt181=substr(scan(collection_date,181,"|"),5);
coll_dt182=substr(scan(collection_date,182,"|"),5);
coll_dt183=substr(scan(collection_date,183,"|"),5);
coll_dt184=substr(scan(collection_date,184,"|"),5);
coll_dt185=substr(scan(collection_date,185,"|"),5);
coll_dt186=substr(scan(collection_date,186,"|"),5);
coll_dt187=substr(scan(collection_date,187,"|"),5);
coll_dt188=substr(scan(collection_date,188,"|"),5);
coll_dt189=substr(scan(collection_date,189,"|"),5);
coll_dt190=substr(scan(collection_date,190,"|"),5);
coll_dt191=substr(scan(collection_date,191,"|"),5);
coll_dt192=substr(scan(collection_date,192,"|"),5);
coll_dt193=substr(scan(collection_date,193,"|"),5);
coll_dt194=substr(scan(collection_date,194,"|"),5);
coll_dt195=substr(scan(collection_date,195,"|"),5);
coll_dt196=substr(scan(collection_date,196,"|"),5);
coll_dt197=substr(scan(collection_date,197,"|"),5);
coll_dt198=substr(scan(collection_date,198,"|"),5);
coll_dt199=substr(scan(collection_date,199,"|"),5);
coll_dt200=substr(scan(collection_date,200,"|"),5);

run;



data report_dt (keep = investigationid referral_date report_date report_dt1-report_dt200);
set labs4;
report_dt1=substr(scan(report_date,1,"|"),5);
report_dt2=substr(scan(report_date,2,"|"),5);
report_dt3=substr(scan(report_date,3,"|"),5);
report_dt4=substr(scan(report_date,4,"|"),5);
report_dt5=substr(scan(report_date,5,"|"),5);
report_dt6=substr(scan(report_date,6,"|"),5);
report_dt7=substr(scan(report_date,7,"|"),5);
report_dt8=substr(scan(report_date,8,"|"),5);
report_dt9=substr(scan(report_date,9,"|"),5);
report_dt10=substr(scan(report_date,10,"|"),5);
report_dt11=substr(scan(report_date,11,"|"),5);
report_dt12=substr(scan(report_date,12,"|"),5);
report_dt13=substr(scan(report_date,13,"|"),5);
report_dt14=substr(scan(report_date,14,"|"),5);
report_dt15=substr(scan(report_date,15,"|"),5);
report_dt16=substr(scan(report_date,16,"|"),5);
report_dt17=substr(scan(report_date,17,"|"),5);
report_dt18=substr(scan(report_date,18,"|"),5);
report_dt19=substr(scan(report_date,19,"|"),5);
report_dt20=substr(scan(report_date,20,"|"),5);
report_dt21=substr(scan(report_date,21,"|"),5);
report_dt22=substr(scan(report_date,22,"|"),5);
report_dt23=substr(scan(report_date,23,"|"),5);
report_dt24=substr(scan(report_date,24,"|"),5);
report_dt25=substr(scan(report_date,25,"|"),5);
report_dt26=substr(scan(report_date,26,"|"),5);
report_dt27=substr(scan(report_date,27,"|"),5);
report_dt28=substr(scan(report_date,28,"|"),5);
report_dt29=substr(scan(report_date,29,"|"),5);
report_dt30=substr(scan(report_date,30,"|"),5);
report_dt31=substr(scan(report_date,31,"|"),5);
report_dt32=substr(scan(report_date,32,"|"),5);
report_dt33=substr(scan(report_date,33,"|"),5);
report_dt34=substr(scan(report_date,34,"|"),5);
report_dt35=substr(scan(report_date,35,"|"),5);
report_dt36=substr(scan(report_date,36,"|"),5);
report_dt37=substr(scan(report_date,37,"|"),5);
report_dt38=substr(scan(report_date,38,"|"),5);
report_dt39=substr(scan(report_date,39,"|"),5);
report_dt40=substr(scan(report_date,40,"|"),5);
report_dt41=substr(scan(report_date,41,"|"),5);
report_dt42=substr(scan(report_date,42,"|"),5);
report_dt43=substr(scan(report_date,43,"|"),5);
report_dt44=substr(scan(report_date,44,"|"),5);
report_dt45=substr(scan(report_date,45,"|"),5);
report_dt46=substr(scan(report_date,46,"|"),5);
report_dt47=substr(scan(report_date,47,"|"),5);
report_dt48=substr(scan(report_date,48,"|"),5);
report_dt49=substr(scan(report_date,49,"|"),5);
report_dt50=substr(scan(report_date,50,"|"),5);
report_dt51=substr(scan(report_date,51,"|"),5);
report_dt52=substr(scan(report_date,52,"|"),5);
report_dt53=substr(scan(report_date,53,"|"),5);
report_dt54=substr(scan(report_date,54,"|"),5);
report_dt55=substr(scan(report_date,55,"|"),5);
report_dt56=substr(scan(report_date,56,"|"),5);
report_dt57=substr(scan(report_date,57,"|"),5);
report_dt58=substr(scan(report_date,58,"|"),5);
report_dt59=substr(scan(report_date,59,"|"),5);
report_dt60=substr(scan(report_date,60,"|"),5);
report_dt61=substr(scan(report_date,61,"|"),5);
report_dt62=substr(scan(report_date,62,"|"),5);
report_dt63=substr(scan(report_date,63,"|"),5);
report_dt64=substr(scan(report_date,64,"|"),5);
report_dt65=substr(scan(report_date,65,"|"),5);
report_dt66=substr(scan(report_date,66,"|"),5);
report_dt67=substr(scan(report_date,67,"|"),5);
report_dt68=substr(scan(report_date,68,"|"),5);
report_dt69=substr(scan(report_date,69,"|"),5);
report_dt70=substr(scan(report_date,70,"|"),5);
report_dt71=substr(scan(report_date,71,"|"),5);
report_dt72=substr(scan(report_date,72,"|"),5);
report_dt73=substr(scan(report_date,73,"|"),5);
report_dt74=substr(scan(report_date,74,"|"),5);
report_dt75=substr(scan(report_date,75,"|"),5);
report_dt76=substr(scan(report_date,76,"|"),5);
report_dt77=substr(scan(report_date,77,"|"),5);
report_dt78=substr(scan(report_date,78,"|"),5);
report_dt79=substr(scan(report_date,79,"|"),5);
report_dt80=substr(scan(report_date,80,"|"),5);
report_dt81=substr(scan(report_date,81,"|"),5);
report_dt82=substr(scan(report_date,82,"|"),5);
report_dt83=substr(scan(report_date,83,"|"),5);
report_dt84=substr(scan(report_date,84,"|"),5);
report_dt85=substr(scan(report_date,85,"|"),5);
report_dt86=substr(scan(report_date,86,"|"),5);
report_dt87=substr(scan(report_date,87,"|"),5);
report_dt88=substr(scan(report_date,88,"|"),5);
report_dt89=substr(scan(report_date,89,"|"),5);
report_dt90=substr(scan(report_date,90,"|"),5);
report_dt91=substr(scan(report_date,91,"|"),5);
report_dt92=substr(scan(report_date,92,"|"),5);
report_dt93=substr(scan(report_date,93,"|"),5);
report_dt94=substr(scan(report_date,94,"|"),5);
report_dt95=substr(scan(report_date,95,"|"),5);
report_dt96=substr(scan(report_date,96,"|"),5);
report_dt97=substr(scan(report_date,97,"|"),5);
report_dt98=substr(scan(report_date,98,"|"),5);
report_dt99=substr(scan(report_date,99,"|"),5);
report_dt100=substr(scan(report_date,100,"|"),5);
report_dt101=substr(scan(report_date,101,"|"),5);
report_dt102=substr(scan(report_date,102,"|"),5);
report_dt103=substr(scan(report_date,103,"|"),5);
report_dt104=substr(scan(report_date,104,"|"),5);
report_dt105=substr(scan(report_date,105,"|"),5);
report_dt106=substr(scan(report_date,106,"|"),5);
report_dt107=substr(scan(report_date,107,"|"),5);
report_dt108=substr(scan(report_date,108,"|"),5);
report_dt109=substr(scan(report_date,109,"|"),5);
report_dt110=substr(scan(report_date,110,"|"),5);
report_dt111=substr(scan(report_date,111,"|"),5);
report_dt112=substr(scan(report_date,112,"|"),5);
report_dt113=substr(scan(report_date,113,"|"),5);
report_dt114=substr(scan(report_date,114,"|"),5);
report_dt115=substr(scan(report_date,115,"|"),5);
report_dt116=substr(scan(report_date,116,"|"),5);
report_dt117=substr(scan(report_date,117,"|"),5);
report_dt118=substr(scan(report_date,118,"|"),5);
report_dt119=substr(scan(report_date,119,"|"),5);
report_dt120=substr(scan(report_date,120,"|"),5);
report_dt121=substr(scan(report_date,121,"|"),5);
report_dt122=substr(scan(report_date,122,"|"),5);
report_dt123=substr(scan(report_date,123,"|"),5);
report_dt124=substr(scan(report_date,124,"|"),5);
report_dt125=substr(scan(report_date,125,"|"),5);
report_dt126=substr(scan(report_date,126,"|"),5);
report_dt127=substr(scan(report_date,127,"|"),5);
report_dt128=substr(scan(report_date,128,"|"),5);
report_dt129=substr(scan(report_date,129,"|"),5);
report_dt130=substr(scan(report_date,130,"|"),5);
report_dt131=substr(scan(report_date,131,"|"),5);
report_dt132=substr(scan(report_date,132,"|"),5);
report_dt133=substr(scan(report_date,133,"|"),5);
report_dt134=substr(scan(report_date,134,"|"),5);
report_dt135=substr(scan(report_date,135,"|"),5);
report_dt136=substr(scan(report_date,136,"|"),5);
report_dt137=substr(scan(report_date,137,"|"),5);
report_dt138=substr(scan(report_date,138,"|"),5);
report_dt139=substr(scan(report_date,139,"|"),5);
report_dt140=substr(scan(report_date,140,"|"),5);
report_dt141=substr(scan(report_date,141,"|"),5);
report_dt142=substr(scan(report_date,142,"|"),5);
report_dt143=substr(scan(report_date,143,"|"),5);
report_dt144=substr(scan(report_date,144,"|"),5);
report_dt145=substr(scan(report_date,145,"|"),5);
report_dt146=substr(scan(report_date,146,"|"),5);
report_dt147=substr(scan(report_date,147,"|"),5);
report_dt148=substr(scan(report_date,148,"|"),5);
report_dt149=substr(scan(report_date,149,"|"),5);
report_dt150=substr(scan(report_date,150,"|"),5);
report_dt151=substr(scan(report_date,151,"|"),5);
report_dt152=substr(scan(report_date,152,"|"),5);
report_dt153=substr(scan(report_date,153,"|"),5);
report_dt154=substr(scan(report_date,154,"|"),5);
report_dt155=substr(scan(report_date,155,"|"),5);
report_dt156=substr(scan(report_date,156,"|"),5);
report_dt157=substr(scan(report_date,157,"|"),5);
report_dt158=substr(scan(report_date,158,"|"),5);
report_dt159=substr(scan(report_date,159,"|"),5);
report_dt160=substr(scan(report_date,160,"|"),5);
report_dt161=substr(scan(report_date,161,"|"),5);
report_dt162=substr(scan(report_date,162,"|"),5);
report_dt163=substr(scan(report_date,163,"|"),5);
report_dt164=substr(scan(report_date,164,"|"),5);
report_dt165=substr(scan(report_date,165,"|"),5);
report_dt166=substr(scan(report_date,166,"|"),5);
report_dt167=substr(scan(report_date,167,"|"),5);
report_dt168=substr(scan(report_date,168,"|"),5);
report_dt169=substr(scan(report_date,169,"|"),5);
report_dt170=substr(scan(report_date,170,"|"),5);
report_dt171=substr(scan(report_date,171,"|"),5);
report_dt172=substr(scan(report_date,172,"|"),5);
report_dt173=substr(scan(report_date,173,"|"),5);
report_dt174=substr(scan(report_date,174,"|"),5);
report_dt175=substr(scan(report_date,175,"|"),5);
report_dt176=substr(scan(report_date,176,"|"),5);
report_dt177=substr(scan(report_date,177,"|"),5);
report_dt178=substr(scan(report_date,178,"|"),5);
report_dt179=substr(scan(report_date,179,"|"),5);
report_dt180=substr(scan(report_date,180,"|"),5);
report_dt181=substr(scan(report_date,181,"|"),5);
report_dt182=substr(scan(report_date,182,"|"),5);
report_dt183=substr(scan(report_date,183,"|"),5);
report_dt184=substr(scan(report_date,184,"|"),5);
report_dt185=substr(scan(report_date,185,"|"),5);
report_dt186=substr(scan(report_date,186,"|"),5);
report_dt187=substr(scan(report_date,187,"|"),5);
report_dt188=substr(scan(report_date,188,"|"),5);
report_dt189=substr(scan(report_date,189,"|"),5);
report_dt190=substr(scan(report_date,190,"|"),5);
report_dt191=substr(scan(report_date,191,"|"),5);
report_dt192=substr(scan(report_date,192,"|"),5);
report_dt193=substr(scan(report_date,193,"|"),5);
report_dt194=substr(scan(report_date,194,"|"),5);
report_dt195=substr(scan(report_date,195,"|"),5);
report_dt196=substr(scan(report_date,196,"|"),5);
report_dt197=substr(scan(report_date,197,"|"),5);
report_dt198=substr(scan(report_date,198,"|"),5);
report_dt199=substr(scan(report_date,199,"|"),5);
report_dt200=substr(scan(report_date,200,"|"),5);

run;

 /*sort and format collection date table*/
proc sort data = coll_dt; by investigationid referral_date;run;
proc transpose data = coll_dt out = collectdate;
	by investigationid referral_date;
	var coll_dt1-coll_dt200;
run;

data collectdate2;
	set collectdate;
	format collection_date date9. record best12.;
	temp = substr(_name_,8);
	collection_date = input(col1, mmddyy10.);
	record= input(temp, best12.);
	drop _name_ col1 temp;
run;

/*sort and format report date table*/
proc sort data = report_dt; by investigationid referral_date;run;
proc transpose data = report_dt out = reportdate;
	by investigationid referral_date;
	var report_dt1-report_dt200;
run;

data reportdate2;
	set reportdate;
	format report_date date9. record best12.;
	temp = substr(_name_,10);
	report_date = input(col1, mmddyy10.);
	record= input(temp, best12.);
	drop _name_ col1 temp;
run;

/*transpose test name table*/
proc sort data = test_name; by investigationid;run;
proc transpose data = test_name out = test_name2;
	by investigationid;
	var test_name1-test_name200;
run;

data test_name3;
	set test_name2;
	format record best12.;
	temp = substr(_name_,10);
	record= input(temp, best12.);
	rename col1 = test_name;
	label col1 = test_name;
	drop _name_ temp;
run;

/*transpose test result table*/

proc sort data = result; by investigationid;run;
proc transpose data = result out = lab_result;
	by investigationid;
	var result1-result200;
run;

data lab_result2;
	set lab_result;
	format record best12.;
	temp = substr(_name_,7);
	record= input(temp, best12.);
	rename col1 = lab_result;
	label col1 = lab_result;
	drop _name_ temp;
run;

data lab_result3;
	sub = '/';
	set lab_result2;
	lab_result = transtrn(lab_result,'/',trimn(''));
run;

/*Sort tables so records are grouped by investigation ID and sorted by record number*/
proc sort data = reportdate2; by investigationid record; run;
proc sort data = collectdate2; by investigationid record; run;
proc sort data = test_name3; by investigationid record; run;
proc sort data = lab_result3; by investigationid record; run;

/*combining test name, result, collection date and result date tables in a single table - joined on investigation ID and record number*/
data cc.combined;
	merge reportdate2 collectdate2 test_name3 lab_result3;
	by investigationid record;
	if test_name = ' ' then delete;
	if collection_date = . then collection_date = report_date;
	if collection_date > '31dec2021'd then delete;				/*****CHANGE DATE ACCORDING TO ANALYSIS PARAMETERS******/
	drop sub;
run;

/*Index character strings to identify Hep C tests and any non Hep C tests*/
data hcv_only;
	set cc.combined;
	if prxmatch("m/hcv|hepatitis c|hepatitisc|hep c|hepc|hepatits c|hepatitits c|hpe. c|hepatiits c|hepatitas c|hpatitis c/oi",test_name) > 0 then HCV_test = 1;
		else HCV_test = 0;

if prxmatch("m/sars|cov|corona/oi",test_name) > 0 then covid_test = 1;
		else covid_test = 0;


	if hcv_test = 0 then delete;
	if hcv_test + covid_test = 2 then delete;
run;

proc freq data = hcv_only; tables test_name; run;

/*Index test names to identify type of test - Ab, RNA, or genotype*/
data hcv2;
	set hcv_only;

	if prxmatch("m/hcv ab|hcvab|hepatitis c ab|hepatitis c virus ab|hepatitis c virus antibody|hep c ab|hepatitis c antibody|hep c antibody|virus ab|rapid|confirmatory|virus ag|riba|eia|elisa|total ab|hepatitis c a|ahcv|anit-hcv|anti hcv|anti-hcv|c igg|viral ab|hcv antibod/oi",test_name) > 0 
		then ab_test = 1;
		else ab_test = 0;
	if prxmatch("m/rna|NAAT|quantitative|quantitation|quant|qualitative|qual|nat|pcr|qnt|load|log|ultrio|hcvbd/oi",test_name) > 0 
		then rna_test = 1;
		else rna_test = 0;
	if prxmatch("m/genotype|genotyping|subtype|genotyp|gentyp|geno/oi",test_name) > 0 
		then genotype = 1;
		else genotype = 0;

	if prxmatch("m/hcv ab|hcvab|hepatitis c ab|hepatitis c virus ab|hepatitis c virus antibody|hep c ab|hepatitis c antibody|hep c antibody|virus ab|rapid|confirmatory|virus ag|riba|eia|elisa|total ab|hepatitis c a|ahcv|anit-hcv|anti hcv|anti-hcv|c igg|viral ab|hcv antibod/oi",test_name) >0
		and prxmatch("m/rna|NAAT|quantitative|quantitation|quant|qualitative|qual|nat|pcr|qnt|load|log|ultrio/oi",test_name) > 0 
		then rna_test = 0;

	if prxmatch("m/with ref/oi",test_name) > 0
		and prxmatch("m/qual|quan/oi",lab_result) > 0 
		then rna_test1 = 1; 

	if prxmatch("m/with ref/oi",test_name) > 0
		and prxmatch("m/qual|quan/oi",lab_result) = 0 
		then rna_test1 = 0; 

	if genotype = 1 then rna_test = 0;
	if rna_test1 = 1 then rna_test = 1;
		if rna_test1 = 1 then ab_test = 0;

	if ab_test + rna_test + genotype= 0 then review_test = 1;
	if ab_test + rna_test = 2 then review_test = 2;
	if genotype + rna_test = 2 then review_test = 3;
	if rna_test1 = 0 then review_test = 4;
	
run;

data cc.hcv2; set hcv2; run;

/*Export data set for manual review of test names that were not identified by index terms*/
PROC EXPORT DATA= hcv2
            OUTFILE= "C:\Users\harta6\OneDrive - State of Michigan DTMB\Desktop\Yale_Update\Aug 2022\review1.xlsx" 
            DBMS=EXCEL REPLACE;
     SHEET="for review"; 
RUN;

/*manually review necessary labs (anything with a value in review_test column), 
	and enter 99 in the "review" column for any labs to be deleted. Ensure dates are formatted as dates*/
/*Import after manual review*/
proc import out = cc.hcv2
	datafile = "C:\Users\harta6\OneDrive - State of Michigan DTMB\Desktop\Yale_Update\Aug 2022\review1.csv"
	dbms = csv replace;
	guessingrows=max;
run;

/*Delete those tests that were reviewed and need to be discarded*/
data hcv2;
	set cc.hcv2;
	if review_test = 99 then delete;
	drop rna_test1 review_test;
run;

/*Identifcation of numeric operaters within results*/
data hcv3;
	set hcv2;
	format number2 best12.;
	if lab_result = ' ' then delete;

	number = strip(compress(lab_result,'.','kd'));
	character = compress(lab_result);
	if prxmatch("m/log/oi",character) > 0 then sign = 'log';
	if prxmatch("m/iu/oi",character) > 0 then sign = 'iu';
	if prxmatch("m/</oi",character) > 0 then sign = 'lt';
	if prxmatch("m/>/oi",character) > 0 then sign = 'gt';
	if prxmatch("m/=/oi",character) > 0 then sign = 'equal';
	

	number2 = input(number,best12.);
run;

/*Classify numeric results as positive or negative based on sign and value*/
data hcv4;
	set hcv3;
	if number ge 1 and sign in (' ','gt','equ','iu','log') then num_pos = 1;
	if 0 < number < 1 then num_neg = 1;
		else if sign = 'lt' then num_neg = 1;
run;

/*Use index terms to identify qualitative positive or negative results*/
data hcv5;
	set hcv4;

	if prxmatch("m/react|positive|detect|1a|1b|2a|2b|3a/oi",lab_result) > 0 then text_pos = 1;
	if prxmatch("m/not de|nonre|undet|notde|non-re|neg|equiv/oi",lab_result) > 0 then text_neg = 1;

	if prxmatch("m/react|detect/oi",lab_result) > 0
		and prxmatch("m/nonre|non-re|not de|undet|notde|neg|equiv/oi",lab_result) > 0 then text_neg2 = 1; 

	if prxmatch("m/react|detect/oi",lab_result) > 0
		and prxmatch("m/nonre|non-re|not de|undet|notde|neg|QNS|equiv/oi",lab_result) = 0 then text_neg2 = 0;

	if prxmatch("m/L-38806|QNS/oi",lab_result) > 0 then review_lab = 3;

	if num_neg + text_pos + text_neg + text_neg2 = 4 
		and prxmatch("m/antibody/oi",lab_result) > 0 then review_lab = 9;

	if text_neg2 = 1 then text_pos = .;

	if text_pos + text_neg = 2 then review_lab = 1;
	if text_pos + num_neg = 2 then review_lab = 1;
	if text_neg + num_pos = 2 then review_lab = 1;
	if text_pos + text_neg + num_pos + num_neg = 0 then review_lab = 2;
	

run;
/*Run frequency to see how many lab results need review*/
proc freq data = hcv5; table review_lab/norow nocol nocum nopercent; run;

data cc.hcv5; set hcv5; run;

/*Export the dataset for manual review of lab results*/
PROC EXPORT DATA= hcv5
            OUTFILE= "C:\Users\harta6\OneDrive - State of Michigan DTMB\Desktop\Yale_Update\Aug 2022\review2.xlsx" 
            DBMS=EXCEL REPLACE;
     SHEET="for review"; 
RUN;

/*manually review necessary labs if results are discordant - remove any conflicting flags in results so that they are not interpretted both positive and negative*/
proc import out = cc.hcv5
	datafile = "C:\Users\harta6\OneDrive - State of Michigan DTMB\Desktop\Yale_Update\Aug 2022\review2.csv"
	dbms = csv replace;
	guessingrows=max;
run;

/*check for discordant pos/neg results*/
proc freq data = cc.hcv5; table num_pos*num_neg num_pos*text_neg num_pos*text_neg2/norow nocol nocum nopercent; run;
proc freq data = cc.hcv5; table text_pos*num_neg text_pos*text_neg text_pos*text_neg2/norow nocol nocum nopercent; run;

/*Group all records by investigation ID and sort by collection date*/
proc sort data = cc.hcv5; by investigationid collection_date; run;

/*classify test/result combinations into appropriate categories*/
data hcv6;
	set cc.hcv5;
	format result $30.;
	row_id = _n_;
	if ab_test = 1 and num_pos = 1 then result = '1a.Ab Positive';
		else if ab_test = 1 and text_pos = 1 then result = '1a.Ab Positive';

	if ab_test = 1 and num_neg = 1 then result = '1b.Ab Negative';
		else if ab_test = 1 and text_neg = 1 then result = '1b.Ab Negative';

	if rna_test = 1 and num_pos = 1 then result = '2a.RNA Positive';
		else if rna_test = 1 and text_pos = 1 then result = '2a.RNA Positive';

	if rna_test = 1 and num_neg = 1 then result = '2b.RNA Negative';
		else if rna_test = 1 and text_neg = 1 then result = '2b.RNA Negative';

	if genotype = 1 and num_pos = 1 then result = '2a.RNA Positive';
		else if genotype = 1 and text_pos = 1 then result = '2a.RNA Positive';

	if genotype = 1 and num_neg = 1 then result = '2b.RNA Negative';
		else if genotype = 1 and text_neg = 1 then result = '2b.RNA Negative';

	if rna_test = 1 then test_type = 'RNA';
	else if genotype = 1 then test_type = 'RNA';

	if collection_date ge '01jan2022'd then delete;
run;

/*pull out all HCV Ab positive results*/
data ab_analysis;
	set hcv6;
	where result = '1a.Ab Positive';
run;

/*Find and keep only the first HCV Ab positive result*/
data ab_analysis2;
	set ab_analysis;
	by investigationid;
	if first.investigationid then first_posab = 1;
		else first_posab = 2;
run;

proc sql;
	create table hcv7 as
	select a.*, b.first_posab
	from hcv6 a
	left join ab_analysis2 b on (a.row_id = b.row_id);
quit;

proc freq data = hcv7; table result/norow nocol nocum nopercent; run;

data hcv8;
	set hcv7;
	if first_posab = 2 then delete;
	if result in (' ','1b.Ab Negative') then delete;
	if num_pos = 1 then poslab = 1;
		else if text_pos = 1 then poslab = 1;
run;

/*Run frequencies to verify that date range of collection dates is correct*/
proc freq data = hcv8; table collection_date; run;

/*Identify the first positive result*/
data hcv_pos;
	set hcv8;
	if poslab ne 1 then delete;
run;

proc sort data = hcv_pos; by investigationid collection_date; run;
data first_pos;
	format first_pos date9.;
	set hcv_pos;
	by investigationid;

	if first.investigationid then first_pos = collection_date;

	if first_pos = . then delete;
run;

/*Identify most recent positive collection date*/
proc sort data = hcv_pos out = hcv_pos_flip; by investigationid descending collection_date; run;
data last_pos;
	format last_pos date9.;
	set hcv_pos_flip;
	by investigationid;
	if poslab = . then delete;

	if first.investigationid then last_pos = collection_date;

	if last_pos = . then delete;
run;

/*Deleting duplcate tests/results*/
proc sort data = hcv8; by investigationid collection_date result; run;
proc sort data = hcv8 out = hcv8_ nodupkey; by investigationid collection_date result; run;

proc sort data = hcv8_; by investigationid collection_date result; run;
proc sort data = hcv8_ out = hcv8__ nodupkey; by investigationid collection_date test_type; run;

/*Transpose to create a wide table of test/results*/
proc transpose data = hcv8__ out = transpose1;
	by investigationid;
	var result;
run;

options missing=' ';
data transpose2 (keep = investigationid lab_string);
	set transpose1;
	format lab_string $1000.;
	lab_string = catx(" | ",
col1,
col2,
col3,
col4,
col5,
col6,
col7,
col8,
col9,
col10,
col11,
col12,
col13,
col14,
col15,
col16,
col17,
col18,
col19,
col20,
col21,
col22,
col23,
col24,
col25,
col26,
col27,
col28,
col29,
col30,
col31,
col32,
col33,
col34,
col35,
col36,
col37,
col38,
col39,
col40,
col41,
col42,
col43,
col44,
col45,
col46,
col47,
col48,
col49,
col50,
col51,
col52,
col53,
col54,
col55,
col56,
col57,
col58);

run;
/*if you got any error notes on the last step, double check that the formatted lentgth is long enough for concatenation*/


data transpose3;
	set transpose2;

	/*flagging Ab Pos, RNA Pos and RNA Neg within lab sequences*/
	ab_pos = index(lab_string, '1a.Ab Positive');
	rna_pos = index(lab_string, '2a.RNA Positive');
	rna_neg = index(lab_string, '2b.RNA Negative');

	/*cleaning 0s from rna_pos and ab_pos columns*/
	if ab_pos > 0 then ab_pos2 = ab_pos;
		else ab_pos2 = .;
	if rna_pos > 0 then rna_pos2 = rna_pos;
		else rna_pos2 = .;

	/*flagging the first positive result*/
	first_pos = min(ab_pos2,rna_pos2);

	/*created a second string variable of the lab result sequence starting at the first positive result -- discarding negative results that preceded any positives*/
	lab_string2 = substr(lab_string,first_pos);


	rna_pos2 = index(lab_string2, '2a.RNA Positive');
	rna_neg2 = index(lab_string2, '2b.RNA Negative');
	rna_conversion1 = index(lab_string2, '2a.RNA Positive | 2b.RNA Negative');
	rna_conversion2 = index(lab_string2, '2a.RNA Positive | 1a.Ab Positive | 2b.RNA Negative');
	rna_conversion3 = index(lab_string2, '2b.RNA Negative | 2a.RNA Positive');
	rna_conversion4 = index(lab_string2, '2b.RNA Negative | 1a.Ab Positive | 2a.RNA Positive');
	last_test1 = scan(lab_string2,-2);
	last_test2 = scan(lab_string2,-1);
	last_result = catx(' ',last_test1, last_test2);

	/*analyzing if first RNA result was positive or negative*/
	if rna_pos2 > 0 and rna_neg2 = 0 then first_rna = 'pos';
		else if rna_neg2 > 0 and rna_pos2 = 0 then first_rna = 'neg';
		else if rna_neg2 > rna_pos2 then first_rna = 'pos';
		else if rna_pos2 > rna_neg2 then first_rna = 'neg';

	/*identifying if any positive result exists*/
	if ab_pos + rna_pos > 0 then ever_infected = 'B';
		else ever_infected = 'A';

	/*identifying is any RNA results exist*/
	if rna_neg2 + rna_pos2 = 0 then viral_testing = 'A';
		else if rna_neg2 + rna_pos2 > 0 then viral_testing = 'B';

	/*identifying if the initial RNA result was positive or negative*/
	if viral_testing = 'B' and first_rna = 'neg' then initial_infection = 'A';
		else if viral_testing = 'B' and first_rna = 'pos' then initial_infection = 'B';

	/*identifying if cases with initial RNA positive had subsequent RNA negatives*/
	if initial_infection = 'B' and rna_neg2 = 0 then cured_cleared = 'A';
		else if initial_infection = 'B' and rna_conversion1 + rna_conversion2 > 0 then cured_cleared = 'B';
	
	/*identifying reinfections*/
	if initial_infection = 'A' and rna_conversion3 + rna_conversion4 > 0 then reinfection = 'B';
	if cured_cleared = 'B' and rna_conversion3 + rna_conversion4 > 0 then reinfection = 'B';
	
	drop last_test1 last_test2;
run;

/*merging tables to get desired format for export*/
data hcv9 (keep = investigationid referral_date);
	set hcv8; run;

proc sort data = hcv9; by investigationid; run;
proc sort data = hcv9 out = hcv10 nodupkey; by investigationid; run;

proc sql;
	create table final_hcv as
	select a.*, b.*

	from hcv10 a
		left join transpose3 b on (a.investigationid = b.investigationid);
quit;

data cc.final_hcv;
	set final_hcv;
run;

PROC EXPORT DATA= final_hcv
            OUTFILE= "C:\Users\harta6\OneDrive - State of Michigan DTMB\Desktop\Yale_Update\Aug 2022\final_hcv_labs.xlsx" 
            DBMS=EXCEL REPLACE;
     SHEET="HCV cases"; 
RUN;

/*Importing initial coinfected cohort - maintains the same cohorts over time as the baseline assessment*/
proc import out = old_class
	datafile = "C:\Users\harta6\OneDrive - State of Michigan DTMB\Desktop\Yale_Update\coinfected_labs_with_HIVdata.xlsx"
           DBMS=EXCEL REPLACE;
     RANGE="coinfected only$"; 
     GETNAMES=YES;
     MIXED=NO;
     SCANTEXT=YES;
     USEDATE=YES;
     SCANTIME=YES;
RUN;

data old_class2;
	set old_class;
	format ref_date date9.;
	if investigation_id = 14178254864 then investigation_id = 19772895507;
	if investigation_id = . then delete;
	ref_date = '31dec2021'd; 					/*******************UPDATE DATE ON THIS ROW*****************************/
run;

proc sql;
	create table all_coinfect as
	select a.*, b.lab_string2, b.last_result, b.ever_infected, b.viral_testing, b.initial_infection, b.cured_cleared, b.reinfection, c.first_pos as firstlab,
			d.last_pos as lastlab
	from old_class2 a
	left join final_hcv b on (a.investigation_id = b.investigationid)
	left join first_pos c on (a.investigation_id = c.investigationid)
	left join last_pos d on (a.investigation_id = d.investigationid);
quit;

/*categorizing all variables into neccesary formats*/
data all_coinfect2;
	set all_coinfect;
	format category2 $30.;
	time_firstpos2 = ref_date - firstlab;
	time_recent2 = ref_date - lastlab;

	if time_firstpos2 lt 365 then first_grp2 = '1. <1 yr';
	else if time_firstpos2 ge 365 and time_firstpos2 lt 730 then first_grp2 = '2. 1-2 yr';
	else if time_firstpos2 ge 730 and time_firstpos2 lt 1825 then first_grp2 = '3. 2-5 yr';
	else if time_firstpos2 ge 1825 then first_grp2 = '4. >5 yr';

	if time_recent2 lt 365 then last_grp2 = '1. <1 yr';
	else if time_recent2 ge 365 and time_recent2 lt 730 then last_grp2 = '2. 1-2 yr';
	else if time_recent2 ge 730 and time_recent2 lt 1825 then last_grp2 = '3. 2-5 yr';
	else if time_recent2 ge 1825 then last_grp2 = '4. >5 yr';

	if firstlab = . then first_grp2 = ' ';
	if lastlab = . then last_grp2 = ' ';

	if ever_infected = ' ' and viral_testing = ' ' and initial_infection = ' ' and cured_cleared = ' ' and reinfection = ' ' then category2 = 'ab +, no pcr';
	else if ever_infected = 'A' and viral_testing = 'A' and initial_infection = ' ' and cured_cleared = ' ' and reinfection = ' ' then category2 = 'ab +, no pcr';
	else if ever_infected = 'B' and viral_testing = 'A' and initial_infection = ' ' and cured_cleared = ' ' and reinfection = ' ' then category2 = 'ab +, no pcr';
	else if ever_infected = 'B' and viral_testing = 'B' and initial_infection = 'A' and cured_cleared = ' ' and reinfection = ' ' then category2 = 'ab +, pcr -';
	else if ever_infected = 'B' and viral_testing = 'B' and initial_infection = 'B' and cured_cleared = 'A' and reinfection = ' ' then category2 = 'pcr + [no pcr -]';
	else if ever_infected = 'B' and viral_testing = 'B' and initial_infection = 'B' and cured_cleared = 'B' and reinfection = ' ' then category2 = 'pcr +, pcr -';
	else if ever_infected = 'B' and viral_testing = 'B' and initial_infection = 'B' and cured_cleared = 'B' and reinfection = 'B' then category2 = 'pcr +, pcr -, pcr +';
	else category2 = 'REVIEW 1';

	if category2 = 'ab +, pcr -' and last_result = 'RNA Positive' then category2 = 'REVIEW 2';
	if category2 = 'pcr + [no pcr -]' and last_result = 'RNA Negative' then category2 = 'REVIEW 3';
	if category2 = 'pcr +, pcr -' and last_result = 'RNA Positive' then category2 = 'REVIEW 4';
	if category2 = 'pcr +, pcr -, pcr +' and last_result = 'RNA Negative' then category2 = 'REVIEW 5';
run;

/*exporting finalized dataset for aggregation via pivot tables*/
PROC EXPORT DATA= all_coinfect2
            OUTFILE= "C:\Users\harta6\OneDrive - State of Michigan DTMB\Desktop\Yale_Update\Aug 2022\final_compare2.xlsx" 
            DBMS=EXCEL REPLACE;
     SHEET="coinfections"; 
RUN;


/*create category2 variable in final_compare2 file to manually classify lab sequences (extra safeguard to verify accuracy), then re-import for analysis*/

proc import out = import2
	datafile = "C:\Users\harta6\OneDrive - State of Michigan DTMB\Desktop\Yale_Update\Aug 2022\final_compare2.xlsx"
           DBMS=EXCEL REPLACE;
     RANGE="coinfections$"; 
     GETNAMES=YES;
     MIXED=NO;
     SCANTEXT=YES;
     USEDATE=YES;
     SCANTIME=YES;
RUN;

proc import out = import_rw
	datafile = "C:\Users\harta6\OneDrive - State of Michigan DTMB\Desktop\Yale_Update\Aug 2022\final_compare2.xlsx"
           DBMS=EXCEL REPLACE;
     RANGE="RW$"; 
     GETNAMES=YES;
     MIXED=NO;
     SCANTEXT=YES;
     USEDATE=YES;
     SCANTIME=YES;
RUN;

/*Bringing back in updated HIV data*/
proc sql;
	create table updated_hiv as
	select a.*, b.pp_prev_category, b.vital_status, b.age_group as age_new, b.gender as gender_new, b.risk as risk_new, 
			b.viral_suppression_status as vir_supp_new, b.time_since_last_lab as time_since_last_lab_new

	from work.import2 a
	left join tmp1.hiv_hcv_31dec2021 b on (a.stateno = b.stateno); /*******UPDATE FILE NAME*********/
quit;

/*Bringing back in updated HIV data*/
proc sql;
	create table updated_hiv_rw as
	select a.*, b.pp_prev_category, b.vital_status, b.age_group as age_new, b.gender as gender_new, b.risk as risk_new, 
			b.viral_suppression_status as vir_supp_new, b.time_since_last_lab as time_since_last_lab_new

	from work.import_rw a
	left join tmp1.hiv_hcv_31dec2021 b on (a.stateno = b.stateno);  /*******UPDATE FILE NAME*********/
quit;

/*Exporting datasets after matching new HIV data*/
PROC EXPORT DATA= updated_hiv
            OUTFILE= "C:\Users\harta6\OneDrive - State of Michigan DTMB\Desktop\Yale_Update\Aug 2022\final_compare2.xlsx" 
            DBMS=EXCEL REPLACE;
     SHEET="coinfections_update"; 
RUN;

PROC EXPORT DATA= updated_hiv_rw
            OUTFILE= "C:\Users\harta6\OneDrive - State of Michigan DTMB\Desktop\Yale_Update\Aug 2022\final_compare2.xlsx" 
            DBMS=EXCEL REPLACE;
     SHEET="RW_update"; 
RUN;

/*Adjusting categories to account for RNA sequences that indicate multiple viral clearances*/
data updated_hiv2;
set updated_hiv;
category3 = category2;
if category3 = 'pcr +, pcr -, pcr +, pcr -' then category3 = 'pcr +, pcr -';
if category3 = 'pcr+, pcr -' then category3 = 'pcr +, pcr -';
run;

data updated_hiv_rw2;
set updated_hiv_rw;
category3 = category2;
if category3 = 'pcr +, pcr -, pcr +, pcr -' then category3 = 'pcr +, pcr -';
if category3 = 'pcr+, pcr -' then category3 = 'pcr +, pcr -';
run; 

/*Data analysis*/
proc sort data = updated_hiv2; by category3; run;
proc univariate data = updated_hiv2; where vital_status in ('Alive', ' ') and pp_prev_category in ('MI res','UNKNOWN res'); var age; by category3; run;

proc sort data = updated_hiv_rw2; by category3; run;
proc univariate data = updated_hiv_rw2; where vital_status in ('Alive', ' ') and pp_prev_category in ('MI res','UNKNOWN res'); var age; by category3; run;
	
proc freq data = tmp1.hiv_hcv_30jun2021; table vital_status; run;

data temp;
	set tmp1.hiv_hcv_31dec2021;
	if pp_prev_category ne 'MI res' then residence = 'Non MI';
		else residence = 'MI';
	run;




proc sort data = temp; by residence; run;
proc univariate data = temp; where vital_status ne 'Deceased'; var age; by residence; run;

proc sort data = temp; by residence; run;
proc univariate data = temp; where vital_status ne 'Deceased' and Ryan_White = 1; var age; by residence; run;



proc sort data = temp; by vital_status; run;
proc univariate data = temp; where vital_status = 'Deceased'; var age; run;

proc sort data = temp; by vital_status; run;
proc univariate data = temp; where vital_status = 'Deceased' and Ryan_White = 1; var age; run;
